# netbots.tcl v2.20 (23 June 1999)
# copyright  1998, 1999 by slennox <slennox@egghelp.org>

## Please read netbots.txt and components.txt before using this script. ##

# Settings updates
# v2.20 - Added 'nb_group' and 'nb_defctrl' in netbots.tcl, 'ex_clearbans'
# in extras.tcl, 'sl_shortlock' in sentinel.tcl
# v2.13 - Added 'bop_maxreq' in botnetop.tcl, 'sl_banmax' in sentinel.tcl
# v2.10 - Added 'ex_cleanup' in extras.tcl, 'sl_txflood' and 'sl_boban' in
# sentinel.tcl

# netbots.tcl settings
set nb_flag N
set nb_key "changethis"
#set nb_group(cats) "Burmese,Persian,Siamese"
#set nb_group(dogs) "Doberman,Whippet"
set nb_defctrl "*"
set nb_owner 0
set nb_hub 0
set nb_max 3
set nb_timeout 180
set nb_nudisable 0
set nb_autopass 0
set nb_update "YourNick"
set nb_broadcast ""
set nb_chanmode "+nt"
set nb_idlekick 0
set nb_floodchan 10:60
set nb_flooddeop 3:10
set nb_floodkick 3:10
set nb_floodjoin 5:60
set nb_floodctcp 3:60
set nb_chansets "-clearbans +enforcebans +dynamicbans +userbans -autoop -bitch -greet +protectops -statuslog -stopnethack -revenge -autovoice +secret +shared +cycle"

# aidle.tcl settings
set nb_component(aidle) 0
set ai_chan "#yourchannel"
set ai_time 60
set ai_uidle 0
set ai_msgs {
  "*yawn*"
  "la la la"
  "hahahaha"
  "hehehe"
  "hello"
  "hi"
  "rofl"
}

# botnetop.tcl settings
set nb_component(botnetop) 0
set bop_delay 20
set bop_maxreq 3
set bop_linkop 1
set bop_checkop 0
set bop_addhost 0
set bop_log 2

# chanlimit.tcl settings
set nb_component(chanlimit) 0
set cl_chans ""
set cl_echans ""
set cl_limit 10
set cl_grace 2
set cl_timer 10

# extras.tcl settings
set nb_component(extras) 0
set ex_chon 0
set ex_cleanup 0
set ex_clearbans 0
set ex_sendlog 0

# mainserver.tcl settings
set nb_component(mainserver) 0
set ms_mserver "irc.chitchat.net:6668"
set ms_servers {
  irc.talktome.com
  irc.blahblahblah.org:6664
  irc.chinwaggers.net
}
set ms_chktime 120
set ms_tryagn 300
set ms_note "YourNick"
set ms_chan "#yourchannel"
set ms_needbot 1

# masskick.tcl settings
set nb_component(masskick) 0
set mk_reason "closing temporarily"
set mk_kicks 1

# nocycle.tcl settings
set nb_component(nocycle) 0

# repeat.tcl settings
set nb_component(repeat) 0
set rp_kflood 3:60
set rp_kreason "stop repeating"
set rp_bflood 5:60
set rp_breason "repeat flood"
set rp_sflood 3:240
set rp_sreason "stop repeating"
set rp_slength 40
set rp_mtime 240
set rp_mreason "multiple repeat floods"
set rp_btime 60

# sentinel.tcl settings
set nb_component(sentinel) 0
set sl_bcflood 5:30
set sl_bmflood 6:20
set sl_ccflood 5:20
set sl_avflood 6:20
set sl_txflood 50:25
set sl_boflood 4:20
set sl_jflood 6:20
set sl_nkflood 6:20
set sl_ban 1440
set sl_boban 1440
set sl_globalban 0
set sl_banmax 100
set sl_igtime 240
set sl_kick 1
set sl_ilocktime 120
set sl_mlocktime 60
set sl_shortlock 0
set sl_bfmaxbans 19
set sl_note "YourNick"
set sl_cfnotice "Channel locked temporarily due to flood, sorry for any inconvenience this may cause :-)"
set sl_bfnotice "Channel locked temporarily due to full ban list, sorry for any inconvenience this may cause :-)"
set sl_lockcmds 2
set sl_lockflags "o"
set sl_bxsimul 0

# serverlist.tcl settings
set nb_component(serverlist) 0
set sv_servers {
  irc.talktome.com
  irc.blahblahblah.org:6664
  irc.chinwaggers.net
}

# superbitch.tcl settings
set nb_component(superbitch) 0
set sb_chans ""
set sb_canop "m"
set sb_canopflags "o"
set sb_canopany "b"
set sb_remove 0
set sb_note "YourNick"


# Start of main script and components

set nb_ver "v2.20"
set nb_numver "2200"
putlog "Loading netbots.tcl $nb_ver by slennox..."

if {[string trimleft [lindex [split $version] 1] 0] < 1031700} {
  die "netbots.tcl $nb_ver requires eggdrop 1.3.17 or later. Please upgrade your eggdrop, or remove the script."
}

if {$numversion < 1032500} {
proc islinked {arg} {
  if {[lsearch -exact [string tolower [bots]] [string tolower [slindex $arg 0]]] == -1} {
    return 0
  } else {
    return 1
  }
}
}

if {$numversion < 1032400} {
proc putquick {arg} {
  putserv $arg
}
proc botonchan {arg} {
  global botnick
  set chan [slindex $arg 0]
  if {![validchan $chan]} {
    error "illegal channel: $chan"
  } elseif {![onchan $botnick $chan]} {
    return 0
  } else {
    return 1
  }
}
}

proc isbotnetnick {arg} {
  global botnet-nick
  if {[string tolower $arg] == [string tolower ${botnet-nick}]} {
    return 1
  } else {
    return 0
  }
}

proc slindex {arg n} {
  return [lindex [split $arg] $n]
}

proc stl {arg} {
  return [string tolower $arg]
}


# netbots.tcl

proc nb_dccnethelp {hand idx arg} {
  global ex_sendlog nb_component nb_ver
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# nethelp $arg"
  set command [slindex $arg 0]
  if {[string index $command 0] == "."} {
    set command [string range $command 1 end]
  }
  switch -exact -- [stl $command] {
    "" {
      putidx $idx "netbots.tcl $nb_ver DCC commands:"
      putidx $idx "  netbots       netcontrol    netinfo       netshell"
      putidx $idx "  netserv       netpass       netsave       nethash"
      putidx $idx "  netsay        netact        netnotice     netdump"
      putidx $idx "  netjoin       netpart       netchanset    netcycle"
      putidx $idx "  netupdate"
      if {$nb_component(chanlimit)} {
        putidx $idx " "
        putidx $idx "chanlimit.tcl DCC commands:"
        putidx $idx "  dolimit       stoplimit     startlimit"
      }
      if {$nb_component(extras) && $ex_sendlog} {
        putidx $idx " "
        putidx $idx "extras.tcl DCC commands:"
        putidx $idx "  clearbans     clearignores  sendlog"
      }
      if {$nb_component(mainserver)} {
        putidx $idx " "
        putidx $idx "mainserver.tcl DCC commands:"
        putidx $idx "  mserver       mservers      msreset"
      }
      if {$nb_component(masskick)} {
        putidx $idx " "
        putidx $idx "masskick.tcl DCC commands:"
        putidx $idx "  mk"
      }
      if {$nb_component(sentinel)} {
        putidx $idx " "
        putidx $idx "sentinel.tcl DCC commands:"
        putidx $idx "  sentinel      lc            uc"
      }
      putidx $idx " "
      putidx $idx "For more information about a particular command,"
      putidx $idx "type .nethelp <command>"
    }
    "nethelp" {
      putidx $idx "# .nethelp \[command\]"
      putidx $idx "   Displays information about the specified command. If no command is"
      putidx $idx "   specified, this will display a list of all the available netbot"
      putidx $idx "   commands."
    }
    "netbots" {
      putidx $idx "# .netbots \[add/remove <handle>\]"
      putidx $idx "   This command lets you add a bot to or remove a bot from the netbot"
      putidx $idx "   list. It automatically gives the specified bot the netbot flag. The"
      putidx $idx "   bot will only send commands to and receive commands from other"
      putidx $idx "   netbots. If no options are specified, this command lists all"
      putidx $idx "   current netbots."
      putidx $idx "   Note: this command is not used if nb_flag is set to 'b' or 'all' in"
      putidx $idx "   the script's options."
    }
    "netcontrol" {
      putidx $idx "# .netcontrol \[*/group/bot1,bot2,etc\]"
      putidx $idx "   Allows you to select which netbots to control with netbot commands."
      putidx $idx "   Specifying '*' will let you control the current bot and all other"
      putidx $idx "   netbots. Specifying a group of netbots (as defined in the config"
      putidx $idx "   file using 'nb_group') will make netbot commands control that group"
      putidx $idx "   only (only including the current bot if it's part of the group)."
      putidx $idx "   Specifying a list of bots (separated by commas or spaces) will make"
      putidx $idx "   netbot commands control that list of bots only (only including the"
      putidx $idx "   current bot if it's listed)."
      putidx $idx "   The netcontrol command is effective until you sign off from the"
      putidx $idx "   bot. So, for example, if you use .netcontrol \[group\], any netbot"
      putidx $idx "   commands you use will control that group, until you either use"
      putidx $idx "   .netcontrol to change the bots to control, or sign off from the"
      putidx $idx "   bot."
    }
    "netinfo" {
      putidx $idx "# .netinfo"
      putidx $idx "   Displays information about the version of netbots.tcl each netbot"
      putidx $idx "   is running, and the components each has loaded (if any)."
    }
    "netshell" {
      putidx $idx "# .netshell"
      putidx $idx "   Displays brief information about the shell each netbot is running"
      putidx $idx "   on, including operating system, uptime, and load averages."
    }
    "netserv" {
      putidx $idx "# .netserv"
      putidx $idx "   Displays information about the server each netbot is using."
    }
    "netpass" {
      putidx $idx "# .netpass \[password \[handle\]\]"
      putidx $idx "   This command works in different ways depending on which options are"
      putidx $idx "   specified. If both a password and handle are specified, this will"
      putidx $idx "   change the password for that particular user across the botnet. If"
      putidx $idx "   only a password is specified, this changes the 'netbot password'"
      putidx $idx "   (the userfile password each netbot has for all other netbots) to"
      putidx $idx "   the specified password. If no options are specified, this changes"
      putidx $idx "   the netbot password to a random alpha-numeric string."
      putidx $idx "   Note: if you set nb_flag to 'b' or 'all' in the script's options"
      putidx $idx "   this command is only partially enabled - you can change the"
      putidx $idx "   password for a particular user, but cannot change the netbot"
      putidx $idx "   password."
      putidx $idx "# .netpass -check"
      putidx $idx "   Displays a list of users without a password set for each netbot."
    }
    "netsave" {
      putidx $idx "# .netsave"
      putidx $idx "   Makes all netbots perform a userfile/channel file save."
    }
    "nethash" {
      putidx $idx "# .nethash"
      putidx $idx "   Makes all netbots perform a rehash."
    }
    "netsay" {
      putidx $idx "# .netsay <#channel/nick> <message>"
      putidx $idx "   Makes all netbots say the specified message to the specified"
      putidx $idx "   channel or nick."
    }
    "netact" {
      putidx $idx "# .netact <#channel/nick> <message>"
      putidx $idx "   Makes all netbots perform the specified action to the specified"
      putidx $idx "   channel or nick."
    }
    "netnotice" {
      putidx $idx "# .netnotice <#channel/nick> <notice>"
      putidx $idx "   Makes all netbots send the specified notice to the specified"
      putidx $idx "   channel or nick."
    }
    "netdump" {
      putidx $idx "# .netdump <text>"
      putidx $idx "   Makes all netbots send the specified text to the server. Basically"
      putidx $idx "   the same as eggdrop's .dump command. Be careful when using this."
    }
    "netjoin" {
      putidx $idx "# .netjoin <#channel>"
      putidx $idx "   Adds the specified channel to all netbots."
    }
    "netpart" {
      putidx $idx "# .netpart <#channel>"
      putidx $idx "   Removes the specified channel from all netbots."
      putidx $idx "   Tip: if your netbots are 1.3.28+, you can take advantage of the"
      putidx $idx "   'inactive' channel setting to make all netbots temporarily part"
      putidx $idx "   a channel (without losing channel-specific flags, etc.). Simply"
      putidx $idx "   use '.netchanset <#channel> +inactive'."
    }
    "netchanset" {
      putidx $idx "# .netchanset <#channel> \[settings\]"
      putidx $idx "   Allows you to change a channel's settings on all netbots. This"
      putidx $idx "   command works in basically the same way as eggdrop's .chanset"
      putidx $idx "   command. If no settings are specified, the channel's settings are"
      putidx $idx "   changed to the defaults set in the script's options."
      putidx $idx "# .netchanset -reload"
      putidx $idx "   Resets all channel settings as set in the config file. Normally,"
      putidx $idx "   the chanfile will override the config file's channel settings,"
      putidx $idx "   preventing any changes you make from taking effect unless you use"
      putidx $idx "   the .chanset command. This command lets you make changes in the bot"
      putidx $idx "   config files and reload the channel settings from there, without"
      putidx $idx "   the need to disable the chanfile."
    }
    "netcycle" {
      putidx $idx "# .netcycle <#channel>"
      putidx $idx "   Makes all netbots temporarily part the specified channel."
    }
    "netupdate" {
      putidx $idx "# .netupdate \[option\] \[bot\]"
      putidx $idx "   Valid options are -config, -motd, and -script. You should typically"
      putidx $idx "   use this command on the hub bot, after updating config files, motd,"
      putidx $idx "   or netbots.tcl on the hub's shell. If -config is specified, bot"
      putidx $idx "   configs are sent from this bot to other netbots. If motd is"
      putidx $idx "   specified, the motd file(s) is sent to other netbots. If -script is"
      putidx $idx "   specified, the netbots script is sent from this bot to other"
      putidx $idx "   netbots. If a bot is specified, the relevant config file, motd, or"
      putidx $idx "   netbots script is sent to that bot only, instead of updating all"
      putidx $idx "   netbots. See the script documentation for more information about"
      putidx $idx "   this feature."
    }
    "dolimit" {
      putidx $idx "# .dolimit"
      putidx $idx "   Runs limit checking on demand."
    }
    "stoplimit" {
      putidx $idx "# .stoplimit"
      putidx $idx "   Temporarily stops limiting."
    }
    "startlimit" {
      putidx $idx "# .startlimit"
      putidx $idx "   Restarts limiting."
    }
    "clearbans" {
      putidx $idx "# .clearbans \[#channel/global/all\] \[creator\]"
      putidx $idx "   This command is used to clear bans set on the bot. Specifying a"
      putidx $idx "   channel will remove all bans for that channel, specifying 'global'"
      putidx $idx "   will remove all global bans, specifying 'all' will remove all"
      putidx $idx "   global and channel bans. If you specify a creator, only bans set"
      putidx $idx "   by that person will be removed."
    }
    "clearignores" {
      putidx $idx "# .clearignores \[creator\]"
      putidx $idx "   This command is used to clear all ignores set on the bot. If you"
      putidx $idx "   specify a creator, only ignores set by that person will be removed."
    }
    "sendlog" {
      putidx $idx "# .sendlog"
      putidx $idx "   Lists all available logfiles."
      putidx $idx "# .sendlog <nick> <logfile>"
      putidx $idx "   Sends the specified log file to the specified nick via DCC."
    }
    "mserver" {
      putidx $idx "# .mserver"
      putidx $idx "   Displays server/timer details."
      putidx $idx "# .mserver \[server \[port\]\]"
      putidx $idx "   Temporarily changes the bot's main server."
    }
    "mservers" {
      putidx $idx "# .mservers"
      putidx $idx "   Displays server details for all linked bots."
    }
    "msreset" {
      putidx $idx "# .msreset"
      putidx $idx "   Restarts the server checking timer."
    }
    "mk" {
      putidx $idx "# .mk <#channel> \[reason\]"
      putidx $idx "   Sets +i and mass kicks the channel except for opped users, voiced"
      putidx $idx "   users, and +f/o/v users. If no reason is specified, the default"
      putidx $idx "   mass kick reason is used."
    }
    "sentinel" {
      putidx $idx "# .sentinel"
      putidx $idx "   Displays current sentinel.tcl settings."
    }
    "lc" {
      putidx $idx "# .lc \[#channel\]"
      putidx $idx "   Locks the specified channel. If no channel is specified, locks the"
      putidx $idx "   current console channel."
    }
    "uc" {
      putidx $idx "# .uc \[#channel\]"
      putidx $idx "   Unlocks the specified channel. If no channel is specified, unlocks"
      putidx $idx "   the current console channel."
    }
    "default" {
      putidx $idx "$command is not a valid netbot command."
    }
  }
}

proc nb_dccnetbots {hand idx arg} {
  global botnet-nick nb_control nb_flag
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netbots $arg"
  if {$nb_flag == "b" || $nb_flag == "all"} {
    putidx $idx "This command is not used if nb_flag is set to 'b' or 'all'."
    return 0
  }
  set command [slindex $arg 0]
  set bothand [slindex $arg 1]
  if {$command == "add"} {
    if {$bothand == ""} {
      putidx $idx "You must specify a handle."
      return 0
    }
    if {![validuser $bothand]} {
      putidx $idx "$bothand is not a valid user."
      return 0
    }
    if {![matchattr $bothand b]} {
      putidx $idx "$bothand is not a valid bot."
      return 0
    }
    if {[nb_control]} {
      chattr $bothand +$nb_flag
    }
    nb_sendcmd $nb_control "netbots $hand add $bothand"
    putidx $idx "Added $bothand to netbot list."
    return 0
  }
  if {$command == "remove"} {
    if {$bothand == ""} {
      putidx $idx "You must specify a handle."
      return 0
    }
    if {![validuser $bothand]} {
      putidx $idx "$bothand is not a valid user."
      return 0
    }
    if {![matchattr $bothand b]} {
      putidx $idx "$bothand is not a valid bot."
      return 0
    }
    nb_sendcmd $nb_control "netbots $hand remove $bothand"
    if {[nb_control]} {
      chattr $bothand -$nb_flag
    }
    putidx $idx "Removed $bothand from netbot list."
    return 0
  }
  if {$command == ""} {
    set botlist ""
    set offline ""
    foreach netbot [userlist $nb_flag] {
      lappend botlist $netbot
      if {![islinked $netbot] && ![isbotnetnick $netbot]} {
        lappend offline $netbot
      }
    }
    if {$botlist == ""} {
      putidx $idx "There are no netbots."
      return 0
    }
    regsub -all -- " " [join $botlist] ", " botlist
    regsub -all -- " " [join $offline] ", " offline
    if {$offline != ""} {
      putidx $idx "Current netbots: $botlist (offline or not linked: $offline)."
    } else {
      putidx $idx "Current netbots: $botlist (all netbots are online and linked)."
    }
  } else {
    putidx $idx "Usage: .netbots \[add/remove <handle>\]"
  }
}

proc nb_netbots {frombot arg} {
  global nb_flag
  set command [slindex $arg 1]
  set bothand [slindex $arg 2]
  if {![validuser $bothand] || ![matchattr $bothand b]} {return 0}
  if {$command == "add"} {
    chattr $bothand +$nb_flag
    putlog "netbots \[[slindex $arg 0]@$frombot\]: added $bothand to netbot list."
  } elseif {$command == "remove"} {
    chattr $bothand -$nb_flag
    putlog "netbots \[[slindex $arg 0]@$frombot\]: removed $bothand from netbot list."
  }
}

proc nb_dccnetcontrol {hand idx arg} {
  global nb_control nb_group
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netcontrol $arg"
  regsub -all -- ", " $arg "," bots
  regsub -all -- " " $bots "," bots
  if {$bots == ""} {
    if {$nb_control == "*"} {
      putidx $idx "* Controlling all netbots."
    } else {
      regsub -all -- "," $nb_control ", " ctrlbots
      putidx $idx "* Controlling netbots: $ctrlbots"
    }
  } elseif {$bots == "*"} {
    set nb_control "*"
    putidx $idx "* Now controlling all netbots."
  } elseif {[info exists nb_group($bots)]} {
    set nb_control $nb_group($bots)
    regsub -all -- "," $nb_control ", " ctrlbots
    putidx $idx "* Now controlling '$bots' netbots: $ctrlbots"
  } else {
    set nb_control $bots
    regsub -all -- "," $nb_control ", " ctrlbots
    putidx $idx "* Now controlling netbots: $ctrlbots"
  }
}

proc nb_dccnetinfo {hand idx arg} {
  global botnet-nick nb_components nb_control nb_ver
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netinfo $arg"
  if {[nb_control]} {
    putidx $idx "${botnet-nick} is running netbots.tcl $nb_ver (components: $nb_components)"
  }
  nb_sendcmd $nb_control "netinfo $idx"
}

proc nb_netinfo {frombot arg} {
  global nb_components nb_ver
  nb_sendcmd $frombot "rnetinfo [slindex $arg 0] $nb_ver $nb_components"
}

proc nb_rnetinfo {frombot arg} {
  set idx [slindex $arg 0]
  set ver [slindex $arg 1]
  set components [join [lrange [split $arg] 2 end]]
  putidx $idx "$frombot is running netbots.tcl $ver (components: $components)"
}

proc nb_dccnetshell {hand idx arg} {
  global botnet-nick nb_control
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netshell $arg"
  if {[nb_control]} {
    catch {set uptime [string trim [exec uptime]]}
    if {[info exists uptime]} {
      regsub -all -- "  " $uptime " " uptime
      putidx $idx "${botnet-nick} is on [info hostname] - [unames] - $uptime"
    }
  }
  nb_sendcmd $nb_control "netshell $hand $idx"
}

proc nb_netshell {frombot arg} {
  catch {set uptime [string trim [exec uptime]]}
  if {[info exists uptime]} {
    regsub -all -- "  " $uptime " " uptime
    nb_sendcmd $frombot "rnetshell [slindex $arg 1] [info hostname] - [unames] - $uptime"
  }
}

proc nb_rnetshell {frombot arg} {
  putidx [slindex $arg 0] "$frombot is on [join [lrange [split $arg] 1 end]]"
}

proc nb_dccnetserv {hand idx arg} {
  global botnet-nick nb_control numversion server server-online
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netserv $arg"
  if {[nb_control]} {
    if {$server != ""} {
      putidx $idx "${botnet-nick} is connected to $server (connected for [nb_duration [expr [unixtime] - ${server-online}]])"
    } else {
      putidx $idx "${botnet-nick} is not connected to a server."
    }
  }
  nb_sendcmd $nb_control "netserv $hand $idx"
}

proc nb_netserv {frombot arg} {
  global server server-online
  nb_sendcmd $frombot "rnetserv [slindex $arg 1] $server [expr [unixtime] - ${server-online}]"
}

proc nb_rnetserv {frombot arg} {
  global numversion
  set idx [slindex $arg 0]
  set server [slindex $arg 1]
  set connected [slindex $arg 2]
  if {$server != ""} {
    putidx $idx "$frombot is connected to $server (connected for [nb_duration $connected])"
  } else {
    putidx $idx "$frombot is not connected to a server."
  }
}

proc nb_dccnetpass {hand idx arg} {
  global botnet-nick nb_control nb_flag nb_key
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netpass"
  set thepass [slindex $arg 0]
  set forhand [slindex $arg 1]
  if {$forhand == ""} {
    if {$thepass == "-check"} {
      putidx $idx "Checking netbots for users without passwords.."
      if {[nb_control]} {
        set nopass ""
        foreach user [userlist] {
          if {[passwdok $user ""]} {
            lappend nopass $user
          }
        }
        if {$nopass != ""} {
          putidx $idx "${botnet-nick}: [join $nopass ", "]"
        } else {
          putidx $idx "${botnet-nick}: all users have a password set."
        }
      }
      nb_sendcmd $nb_control "netpass $hand $idx [encrypt $nb_key $thepass]"
    } else {
      if {$nb_flag == "b" || $nb_flag == "all"} {
        putidx $idx "You cannot change the netbot password if nb_flag is set to 'b' or 'all'."
        return 0
      }
      set botlist ""
      foreach bot [userlist $nb_flag] {
        if {[isbotnetnick $bot]} {continue}
        if {![islinked $bot]} {
          lappend botlist $bot
        }
      }
      if {$botlist != ""} {
        set botlist [join $botlist ", "]
        putidx $idx "Cannot change netbot password unless all netbots are linked (currently missing: $botlist)."
        return 0
      }
      if {$thepass == ""} {
        set thepass [nb_randpass]
      }
      foreach bot [userlist $nb_flag] {
        setuser $bot PASS $thepass
      }
      nb_sendcmd * "netpass $hand $idx [encrypt $nb_key $thepass]"
      putidx $idx "Changed netbot password to '$thepass'."
    }
  } elseif {$thepass != "" && $forhand != ""} {
    if {![validuser $forhand]} {
      putidx $idx "$forhand is not a valid user."
      return 0
    }
    if {[nb_control]} {
      setuser $forhand PASS $thepass
    }
    nb_sendcmd $nb_control "netpass $hand $idx [encrypt $nb_key $thepass] $forhand"
    putidx $idx "Changed password for $forhand to '$thepass'."
  }
}

proc nb_netpass {frombot arg} {
  global nb_flag nb_key
  set thepass [decrypt $nb_key [slindex $arg 2]]
  set forhand [slindex $arg 3]
  if {$forhand == ""} {
    if {$thepass == "-check"} {
      set nopass ""
      foreach user [userlist] {
        if {[passwdok $user ""]} {
          lappend nopass $user
        }
      }
      if {$nopass != ""} {
        nb_sendcmd $frombot "rnetpass [slindex $arg 1] $nopass"
      } else {
        nb_sendcmd $frombot "rnetpass [slindex $arg 1]"
      }
    } else {
      foreach bot [userlist $nb_flag] {
        setuser $bot PASS $thepass
      }
      putlog "netbots \[[slindex $arg 0]@$frombot\]: changed netbot password."
    }
  } else {
    setuser $forhand PASS $thepass
    putlog "netbots \[[slindex $arg 0]@$frombot\]: changed password for $forhand."
  }
}

proc nb_rnetpass {frombot arg} {
  set idx [slindex $arg 0]
  set nopass [lrange [split $arg] 1 end]
  if {$nopass != ""} {
    putidx $idx "$frombot: [join $nopass ", "]"
  } else {
    putidx $idx "$frombot: all users have a password set."
  }
}

proc nb_dccnetsave {hand idx arg} {
  global nb_control
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netsave $arg"
  putidx $idx "Performing netbot userfile/chanfile save."
  if {[nb_control]} {
    save
  }
  nb_sendcmd $nb_control "netsave $hand"
}

proc nb_netsave {frombot arg} {
  putlog "netbots \[[slindex $arg 0]@$frombot\]: performing netbot userfile/chanfile save."
  save
}

proc nb_dccnethash {hand idx arg} {
  global nb_control
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# nethash $arg"
  putidx $idx "Rehashing netbots."
  if {[nb_control]} {
    uplevel {rehash}
  }
  nb_sendcmd $nb_control "nethash $hand"
}

proc nb_nethash {frombot arg} {
  putlog "netbots \[[slindex $arg 0]@$frombot\]: rehashing."
  uplevel {rehash}
}

proc nb_dccnetsay {hand idx arg} {
  global botnet-nick nb_control
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netsay $arg"
  set sayto [slindex $arg 0]
  set themsg [join [lrange [split $arg] 1 end]]
  if {$sayto == "" || $themsg == ""} {
    putidx $idx "Usage: .netsay <#channel/nick> <message>"
    return 0
  }
  nb_sendcmd $nb_control "netsay $hand $sayto $themsg"
  if {[nb_control]} {
    putserv "PRIVMSG $sayto :$themsg"
  }
}

proc nb_netsay {frombot arg} {
  set sayto [slindex $arg 1]
  putlog "netbots \[[slindex $arg 0]@$frombot\]: sending message to $sayto"
  putserv "PRIVMSG $sayto :[join [lrange [split $arg] 2 end]]"
}

proc nb_dccnetact {hand idx arg} {
  global nb_control
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netact $arg"
  set actto [slindex $arg 0]
  set theact [join [lrange [split $arg] 1 end]]
  if {$actto == "" || $theact == ""} {
    putidx $idx "Usage: .netact <#channel/nick> <action>"
    return 0
  }
  nb_sendcmd $nb_control "netact $hand $actto $theact"
  if {[nb_control]} {
    putserv "PRIVMSG $actto :\001ACTION $theact\001"
  }
}

proc nb_netact {frombot arg} {
  set actto [slindex $arg 1]
  putlog "netbots \[[slindex $arg 0]@$frombot\]: sending action to $actto"
  putserv "PRIVMSG $actto :\001ACTION [join [lrange [split $arg] 2 end]]\001"
}

proc nb_dccnetnotc {hand idx arg} {
  global nb_control
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netnotice $arg"
  set notcto [slindex $arg 0]
  set thenotc [join [lrange [split $arg] 1 end]]
  if {$notcto == "" || $thenotc == ""} {
    putidx $idx "Usage: .netnotice <#channel/nick> <notice>"
    return 0
  }
  nb_sendcmd $nb_control "netnotc $hand $notcto $thenotc"
  if {[nb_control]} {
    putserv "NOTICE $notcto :$thenotc"
  }
}

proc nb_netnotc {frombot arg} {
  set notcto [slindex $arg 1]
  putlog "netbots \[[slindex $arg 0]@$frombot\]: sending notice to $notcto"
  putserv "NOTICE $notcto :[join [lrange [split $arg] 2 end]]"
}

proc nb_dccnetdump {hand idx arg} {
  global nb_control
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netdump $arg"
  if {$arg == ""} {
    putidx $idx "Usage: .netdump <text>"
    return 0
  }
  putidx $idx "Making netbots dump text '$arg'."
  nb_sendcmd $nb_control "netdump $hand $arg"
  if {[nb_control]} {
    putserv $arg
  }
}

proc nb_netdump {frombot arg} {
  set text [join [lrange [split $arg] 1 end]]
  putlog "netbots \[[slindex $arg 0]@$frombot\]: dumping text '$text'."
  putserv $text
}

proc nb_dccnetjoin {hand idx arg} {
  global nb_chanmode nb_chansets nb_control nb_floodchan nb_flooddeop nb_floodkick nb_floodjoin nb_floodctcp nb_idlekick
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netjoin $arg"
  set chan [slindex $arg 0]
  if {[string index $chan 0] != "#"} {
    putidx $idx "Usage: .netjoin <#channel>"
    return 0
  }
  putidx $idx "Adding channel $chan to netbots."
  nb_sendcmd $nb_control "netjoin $hand $chan"
  if {[nb_control]} {
    if {![validchan $chan]} {
      channel add $chan
    }
    channel set $chan chanmode $nb_chanmode
    channel set $chan idle-kick $nb_idlekick
    channel set $chan flood-chan $nb_floodchan
    channel set $chan flood-deop $nb_flooddeop
    channel set $chan flood-kick $nb_floodkick
    channel set $chan flood-join $nb_floodjoin
    channel set $chan flood-ctcp $nb_floodctcp
    eval channel set $chan $nb_chansets
  }
}

proc nb_netjoin {frombot arg} {
  global nb_chanmode nb_chansets nb_floodchan nb_flooddeop nb_floodkick nb_floodjoin nb_floodctcp nb_idlekick
  set chan [slindex $arg 1]
  putlog "netbots \[[slindex $arg 0]@$frombot\]: adding channel $chan"
  if {![validchan $chan]} {
    channel add $chan
  }
  channel set $chan chanmode $nb_chanmode
  channel set $chan idle-kick $nb_idlekick
  channel set $chan flood-chan $nb_floodchan
  channel set $chan flood-deop $nb_flooddeop
  channel set $chan flood-kick $nb_floodkick
  channel set $chan flood-join $nb_floodjoin
  channel set $chan flood-ctcp $nb_floodctcp
  eval channel set $chan $nb_chansets
}

proc nb_dccnetpart {hand idx arg} {
  global nb_control
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netpart $arg"
  set chan [slindex $arg 0]
  if {[string index $chan 0] != "#"} {
    putidx $idx "Usage: .netpart <#channel>"
    return 0
  }
  putidx $idx "Removing channel $chan from netbots."
  nb_sendcmd $nb_control "netpart $hand $chan"
  if {[nb_control]} {
    if {[validchan $chan] && [isdynamic $chan]} {
      channel remove $chan
    }
  }
}

proc nb_netpart {frombot arg} {
  set chan [slindex $arg 1]
  putlog "netbots \[[slindex $arg 0]@$frombot\]: removing channel $chan"
  if {[validchan $chan] && [isdynamic $chan]} {
    channel remove $chan
  }
}

proc nb_dccnetchanset {hand idx arg} {
  global config nb_chanmode nb_chansets nb_control nb_floodchan nb_flooddeop nb_floodkick nb_floodjoin nb_floodctcp nb_idlekick
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netchanset $arg"
  set chan [stl [slindex $arg 0]]
  set settings [lrange [split $arg] 1 end]
  if {$chan == "-reload"} {
    putidx $idx "Making netbots reload channel settings from config file."
    nb_sendcmd $nb_control "netchanset $hand $chan"
    set rfile [open $config r]
    while {![eof $rfile]} {
      set string [gets $rfile]
      if {[string match "channel set *" $string]} {
        eval $string
      }
    }
    close $rfile
    save
    return 0
  }
  if {[string index $chan 0] != "#"} {
    putidx $idx "Usage: .netchanset <#channel> \[settings\]"
    return 0
  }
  if {$settings == ""} {
    putidx $idx "Setting channel settings for $chan to netbots default settings."
    nb_sendcmd $nb_control "netchanset $hand $chan"
    if {[nb_control]} {
      if {[validchan $chan]} {
        channel set $chan chanmode $nb_chanmode
        channel set $chan idle-kick $nb_idlekick
        channel set $chan flood-chan $nb_floodchan
        channel set $chan flood-deop $nb_flooddeop
        channel set $chan flood-kick $nb_floodkick
        channel set $chan flood-join $nb_floodjoin
        channel set $chan flood-ctcp $nb_floodctcp
        eval channel set $chan $nb_chansets
      }
    }
  } else {
    if {[string match "need-*" [lindex $settings 0]]} {
      putidx $idx "You cannot change need-op/invite/key/limit/unban settings."
      return 0
    }
    putidx $idx "Setting channel settings for $chan to '[lrange $settings 0 end]' on netbots."
    nb_sendcmd $nb_control "netchanset $hand $chan $settings"
    if {[nb_control]} {
      if {[validchan $chan]} {
        if {[string index [lindex $settings 0] 0] == "+" || [string index [lindex $settings 0] 0] == "-"} {
          eval channel set $chan $settings
        } else {
          channel set $chan [lindex $settings 0] [lrange $settings 1 end]
        }
      }
    }
  }
}

proc nb_netchanset {frombot arg} {
  global config nb_chanmode nb_chansets nb_floodchan nb_flooddeop nb_floodkick nb_floodjoin nb_floodctcp nb_idlekick
  set chan [slindex $arg 1]
  set settings [lrange [split $arg] 2 end]
  if {$chan == "-reload"} {
    putlog "netbots \[[slindex $arg 0]@$frombot\]: reloading channel settings from config file."
    set rfile [open $config r]
    while {![eof $rfile]} {
      set string [gets $rfile]
      if {[string match "channel set *" $string]} {
        eval $string
      }
    }
    close $rfile
    save
    return 0
  }
  if {$settings == ""} {
    putlog "netbots \[[slindex $arg 0]@$frombot\]: setting channel settings for $chan to netbots default settings."
    if {[validchan $chan]} {
      channel set $chan chanmode $nb_chanmode
      channel set $chan idle-kick $nb_idlekick
      channel set $chan flood-chan $nb_floodchan
      channel set $chan flood-deop $nb_flooddeop
      channel set $chan flood-kick $nb_floodkick
      channel set $chan flood-join $nb_floodjoin
      channel set $chan flood-ctcp $nb_floodctcp
      eval channel set $chan $nb_chansets
    }
  } else {
    if {[string match "need-*" [lindex $settings 0]]} {return 0}
    putlog "netbots \[[slindex $arg 0]@$frombot\]: setting channel settings for $chan to '[lrange $settings 0 end]'."
    if {[validchan $chan]} {
      if {[string index [lindex $settings 0] 0] == "+" || [string index [lindex $settings 0] 0] == "-"} {
        eval channel set $chan $settings
      } else {
        channel set $chan [lindex $settings 0] [lrange $settings 1 end]
      }
    }
  }
}

proc nb_dccnetcycle {hand idx arg} {
  global nb_control
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netcycle $arg"
  set chan [slindex $arg 0]
  if {[string index $chan 0] != "#"} {
    putidx $idx "Usage: .netcycle <#channel>"
    return 0
  }
  putidx $idx "Making netbots cycle $chan."
  nb_sendcmd $nb_control "netcycle $hand $chan"
  if {[nb_control]} {
    if {[validchan $chan]} {
      putserv "PART $chan"
    }
  }
}

proc nb_netcycle {frombot arg} {
  set chan [slindex $arg 1]
  putlog "netbots \[[slindex $arg 0]@$frombot\]: cycling $chan"
  if {[validchan $chan]} {
    putserv "PART $chan"
  }
}

proc nb_dccnetupdate {hand idx arg} {
  global botnet-nick nb_control nb_flag nb_sending
  if {![nb_checkowner $hand $idx]} {return 0}
  putcmdlog "#$hand# netupdate $arg"
  set command [slindex $arg 0]
  if {$command == ""} {
    putidx $idx "Usage: .netupdate \[option\] \[bot\]"
    return 0
  }
  switch -exact -- $command {
    "-config" {
      set file "config"
    }
    "-motd" {
      set file "motd"
    }
    "-script" {
      set file "script"
    }
    "default" {
      putidx $idx "Usage: .netupdate \[option\] \[bot\]"
      return 0
    }
  }
  set bot [slindex $arg 1]
  if {[isbotnetnick $bot]} {
    putidx $idx "Cannot send file to myself."
    return 0
  }
  if {$bot == ""} {
    if {[bots] == ""} {
      putidx $idx "There are no linked bots."
      return 0
    }
    putidx $idx "Initiating transfer of $file to netbots..."
    nb_sendcmd $nb_control "netupdate initiate $file $hand"
  } else {
    if {$nb_flag != "all" && ![matchattr $bot $nb_flag]} {
      putidx $idx "$bot is not a valid netbot."
      return 0
    }
    if {![islinked $bot]} {
      putidx $idx "$bot is not on the botnet."
      return 0
    }
    if {[info exists nb_sending([stl $bot])]} {
      putidx $idx "File transfer to $bot is already active."
      return 0
    }
    putidx $idx "Initiating transfer of $file to $bot..."
    nb_sendcmd $bot "netupdate initiate $file $hand"
  }
}

proc nb_netupdate {frombot arg} {
  global config motd nb_getting nb_script nb_timeout nb_tmpfile nb_ttmpfile twfile wfile
  set command [slindex $arg 0]
  switch -exact -- $command {
    "initiate" {
      if {$nb_getting} {return 0}
      set file [slindex $arg 1]
      set hand [slindex $arg 2]
      if {$hand != ""} {
        putlog "netbots \[$hand@$frombot\]: initiating $file update..."
      } else {
        putlog "netbots \[$frombot\]: initiating $file update..."
      }
      switch -exact -- $file {
        "config" {
          nb_sendcmd $frombot "rnetupdate send $file $config"
        }
        "motd" {
          nb_sendcmd $frombot "rnetupdate send $file $motd"
        }
        "script" {
          nb_sendcmd $frombot "rnetupdate send $file $nb_script"
        }
      }
    }
    "wait" {
      if {$nb_getting} {return 0}
      set file [slindex $arg 1]
      putlog "netbots: $frombot is busy, waiting to try again."
      set nb_getting 1
      switch -exact -- $file {
        "config" {
          utimer [expr 10 + [rand 20]] "nb_wait $frombot $file $config"
        }
        "motd" {
          utimer [expr 5 + [rand 20]] "nb_wait $frombot $file $motd"
        }
        "script" {
          utimer [expr 20 + [rand 20]] "nb_wait $frombot $file $nb_script"
        }
      }
    }
    "start" {
      if {$nb_getting} {return 0}
      set file [slindex $arg 1]
      putlog "netbots: downloading $file from $frombot"
      set nb_getting 1
      utimer $nb_timeout "nb_timeout getting [split $frombot] [split $file]"
      set twfile [open $nb_ttmpfile w]
    }
    "write" {
      if {$nb_getting} {
        puts $twfile [join [lrange [split $arg] 1 end]]
      }
    }
    "end" {
      if {!$nb_getting} {return 0}
      close $twfile
      set wfile [open $nb_tmpfile w]
      set twfile [open $nb_ttmpfile r]
      puts $wfile [read $twfile [expr [file size $nb_ttmpfile] - 2]]
      close $twfile
      file delete -- $nb_ttmpfile
      close $wfile
      set file [slindex $arg 1]
      set filesize [file size $nb_tmpfile]
      set chksize [slindex $arg 2]
      if {$filesize != $chksize} {
        putlog "netbots: error on $file download from $frombot - filesize mismatch (expected $chksize bytes, got $filesize bytes)."
        nb_sendcmd $frombot "rnetupdate fserror $file"
        unset wfile
        foreach utimer [utimers] {
          if {[string match "nb_timeout getting [stl $frombot] *" [stl [lindex $utimer 1]]]} {
            killutimer [lindex $utimer 2]
          }
        }
        set nb_getting 0
        file delete -- $nb_tmpfile
        return 0
      }
      switch -exact -- $file {
        "config" {
          set writefile $config
        }
        "motd" {
          set writefile $motd
        }
        "script" {
          set writefile $nb_script
        }
      }
      file rename -force $nb_tmpfile $writefile
      if {$file == "config"} {
        exec chmod 700 $writefile
      } else {
        exec chmod 600 $writefile
      }
      unset wfile
      foreach utimer [utimers] {
        if {[string match "nb_timeout getting [stl $frombot] *" [stl [lindex $utimer 1]]]} {
          killutimer [lindex $utimer 2]
        }
      }
      nb_sendcmd $frombot "rnetupdate end $file"
      set nb_getting 0
      if {$file == "motd"} {
        putlog "netbots: $file download complete"
      } else {
        putlog "netbots: $file download complete, rehashing..."
        utimer 3 rehash
      }
    }
    "ferror" {
      putlog "netbots: error - $frombot cannot find file '[slindex $arg 1]'."
    }
  }
}

proc nb_rnetupdate {frombot arg} {
  global nb_max nb_sending nb_timeout
  set command [slindex $arg 0]
  set file [slindex $arg 1]
  set filename [slindex $arg 2]
  switch -exact -- $command {
    "initiate" {
      if {[info exists nb_sending([stl $frombot])]} {return 0}
      putlog "netbots: initiating transfer of $file to $frombot..."
      nb_sendcmd $frombot "netupdate initiate $file"
    }
    "send" {
      if {[info exists nb_sending([stl $frombot])]} {return 0}
      if {[llength [array names nb_sending]] >= $nb_max} {
        nb_sendcmd $frombot "netupdate wait $file"
        return 0
      }
      if {![file exists $filename]} {
        putlog "netbots: cannot find file '$filename' (requested by $frombot)."
        nb_sendcmd $frombot "netupdate ferror $filename"
        return 0
      }
      putlog "netbots: sending $file to $frombot"
      set nb_sending([stl $frombot]) 1
      utimer $nb_timeout "nb_timeout sending [split $frombot] [split $file]"
      nb_sendcmd $frombot "netupdate start $file"
      switch -exact -- $file {
        "config" {
          set readfile $filename
        }
        "motd" {
          set readfile $filename
        }
        "script" {
          set readfile $filename
        }
      }
      set rfile([stl $frombot]) [open $readfile r]
      fconfigure $rfile([stl $frombot]) -buffering line
      while {![eof $rfile([stl $frombot])]} {
        set string [gets $rfile([stl $frombot])]
        nb_sendcmd $frombot "netupdate write $string"
      }
      close $rfile([stl $frombot])
      unset rfile([stl $frombot])
      nb_sendcmd $frombot "netupdate end $file [file size $readfile]"
    }
    "end" {
      foreach utimer [utimers] {
        if {[string match "nb_timeout sending [stl $frombot] *" [stl [lindex $utimer 1]]]} {
          killutimer [lindex $utimer 2]
        }
      }
      if {[info exists nb_sending([stl $frombot])]} {
        unset nb_sending([stl $frombot])
      }
      putlog "netbots: completed $file transfer to $frombot"
    }
    "fserror" {
      foreach utimer [utimers] {
        if {[string match "nb_timeout sending [stl $frombot] *" [stl [lindex $utimer 1]]]} {
          killutimer [lindex $utimer 2]
        }
      }
      if {[info exists nb_sending([stl $frombot])]} {
        unset nb_sending([stl $frombot])
      }
      putlog "netbots: error on $file transfer to $frombot - filesize mismatch."
    }
  }
}

proc nb_wait {frombot file filename} {
  global nb_getting
  set nb_getting 0
  nb_sendcmd $frombot "rnetupdate initiate $file $filename"
}

proc nb_timeout {action bot file} {
  global nb_getting nb_sending nb_ttmpfile twfile
  switch -exact -- $action {
    "getting" {
      set nb_getting 0
      catch {close $twfile}
      unset twfile
      catch {set filesize [file size $nb_ttmpfile]}
      catch {file delete -- $nb_ttmpfile}
      if {[info exists filesize]} {
        putlog "netbots: timed out $file download from $bot (got $filesize bytes)"
      } else {
        putlog "netbots: timed out $file download from $bot"
      }
    }
    "sending" {
      if {[info exists nb_sending([stl $bot])]} {
        unset nb_sending([stl $bot])
      }
      putlog "netbots: timed out $file transfer to $bot"
    }
  }
}

proc nb_tautopass {min hour day month year} {
  global botnet-nick nb_flag nb_key
  putlog "netbots: initiating netbot password change..."
  set botlist ""
  foreach bot [userlist $nb_flag] {
    if {[isbotnetnick $bot]} {continue}
    if {![islinked $bot]} {
      lappend botlist $bot
    }
  }
  if {$botlist != ""} {
    set botlist [join $botlist ", "]
    putlog "netbots: cannot change netbot password because not all netbots are linked (currently missing: $botlist)."
    return 0
  }
  set thepass [nb_randpass]
  foreach bot [userlist $nb_flag] {
    setuser $bot PASS $thepass
  }
  save
  nb_sendcmd * "autopass [encrypt $nb_key $thepass]"
  putlog "netbots: changed netbot password."
}

proc nb_autopass {frombot arg} {
  global nb_flag nb_key
  set thepass [decrypt $nb_key [slindex $arg 0]]
  foreach bot [userlist $nb_flag] {
    setuser $bot PASS $thepass
  }
  save
  putlog "netbots \[$frombot\]: changed netbot password."
}

proc nb_update {min hour day month year} {
  global nb_numver nb_update
  timer 3 nb_http
  if {$nb_update != ""} {
    if {[catch {package require http}] == 1} {
      putlog "netbots: error - update check cannot find package 'http' (this feature requires tcl 8.0 or later)."
      return 0
    }
    if {![file exists nbupdate]} {
      set file [open nbupdate w] ; puts $file $nb_numver ; close $file ; unset file
    }
    set ufile [open nbupdate r] ; set unumver [slindex [gets $ufile] 0] ; close $ufile ; unset ufile
    if {[catch {set token [::http::geturl http://www.egghelp.org/netbots/nbupdate.txt]}] == 1} {
      putlog "netbots: error - update check is unable to connect to server (must be down or something)."
      return 0
    }
    set hdata [::http::data $token]
    if {[slindex $hdata 0] != "nbupdate"} {
      putlog "netbots: error - update check did not receive expected response from server."
      return 0
    }
    set hnumver [slindex $hdata 1]
    set ufile [open nbupdate w] ; puts $ufile $hnumver ; close $ufile ; unset ufile
    if {$hnumver > $unumver} {
      foreach recipient [split $nb_update] {
        if {[validuser $recipient]} {
          sendnote NETBOTS $recipient [join [lrange [split $hdata] 2 end]]
        }
      }
    }
  }
}

proc nb_http {} {
  global nb_numver
  if {[catch {set http [socket www.egghelp.org 80]}] != 1} {
    fconfigure $http -translation {auto crlf}
    puts $http "GET /netbots/nb$nb_numver.txt HTTP/1.0"
    puts $http "Accept: */*"
    puts $http "Host: www.egghelp.org"
    puts $http "User-Agent: netbots.tcl http client"
    puts $http ""
    close $http
  }
}

proc nb_chon {hand idx} {
  global nb_control nb_defctrl
  set nb_control $nb_defctrl
}

proc nb_sighup {type} {
  nb_sendcmd * "broadcast Received SIGHUP!"
}

proc nb_sigterm {type} {
  nb_sendcmd * "broadcast Received SIGTERM!"
}

proc nb_svkline {from keyword arg} {
  nb_sendcmd * "broadcast KLINED from $from: [string range [string trimleft $arg :] 0 150]"
}

proc nb_svconnect {from keyword arg} {
  nb_sendcmd * "broadcast Connected to $from"
}

proc nb_broadcast {frombot arg} {
  global nb_broadcast
  if {$nb_broadcast == ""} {return 0}
  foreach dccuser [dcclist] {
    if {[lindex $dccuser 3] == "CHAT"} {
      set idx [lindex $dccuser 0]
      if {[matchattr [idx2hand $idx] $nb_broadcast]} {
        putidx $idx "\[$frombot\]: $arg"
      }
    }
  }
}

proc nb_control {} {
  global botnet-nick nb_control
  if {$nb_control == "*" || [lsearch -exact [split [stl $nb_control] ,] [stl ${botnet-nick}]] != -1} {
    return 1
  } else {
    return 0
  }
}

proc nb_sendcmd {to cmd} {
  global botnet-nick nb_flag nb_key
  set key [encrypt $nb_key "${botnet-nick} $cmd"]
  if {[string length "nb $key"] > 400} {
    putlog "netbots: putbot error - line \"$cmd\" generates an encrypted string exceeding 400 characters. Shorten the line, or try a different key."
  }
  if {$to == "*"} {
    if {$nb_flag == "all"} {
      putallbots "nb $key"
    } else {
      foreach bot [userlist $nb_flag] {
        if {[islinked $bot]} {
          putbot $bot "nb $key"
        }
      }
    }
  } else {
    foreach bot [split $to ,] {
      if {[islinked $bot]} {
        putbot $bot "nb $key"
      }
    }
  }
}

proc nb_gotcmd {frombot cmd arg} {
  global nb_flag nb_hub nb_key nb_nudisable
  set string [decrypt $nb_key $arg]
  set from [slindex $string 0]
  set command [slindex $string 1]
  if {$nb_flag != "all" && ![matchattr $frombot $nb_flag]} {
    putlog "netbots: rejected command from $frombot (not a valid netbot)."
    return 0
  }
  if {$from != $frombot} {
    putlog "netbots: rejected command from $frombot (incorrect key)."
    return 0
  }
  if {$nb_hub && ![matchattr $frombot ||h] && ![string match "r*" $command] && $command != "broadcast" && $command != "sl_lock"} {
    putlog "netbots: rejected command from $frombot (not a hub bot)."
    return 0
  }
  set argstring [join [lrange [split $string] 2 end]]
  switch -exact -- $command {
    "netbots" {
      nb_netbots $frombot $argstring
    }
    "netinfo" {
      nb_netinfo $frombot $argstring
    }
    "rnetinfo" {
      nb_rnetinfo $frombot $argstring
    }
    "netshell" {
      nb_netshell $frombot $argstring
    }
    "rnetshell" {
      nb_rnetshell $frombot $argstring
    }
    "netserv" {
      nb_netserv $frombot $argstring
    }
    "rnetserv" {
      nb_rnetserv $frombot $argstring
    }
    "netpass" {
      nb_netpass $frombot $argstring
    }
    "rnetpass" {
      nb_rnetpass $frombot $argstring
    }
    "netsave" {
      nb_netsave $frombot $argstring
    }
    "nethash" {
      nb_nethash $frombot $argstring
    }
    "netsay" {
      nb_netsay $frombot $argstring
    }
    "netact" {
      nb_netact $frombot $argstring
    }
    "netnotc" {
      nb_netnotc $frombot $argstring
    }
    "netdump" {
      nb_netdump $frombot $argstring
    }
    "netjoin" {
      nb_netjoin $frombot $argstring
    }
    "netpart" {
      nb_netpart $frombot $argstring
    }
    "netchanset" {
      nb_netchanset $frombot $argstring
    }
    "netcycle" {
      nb_netcycle $frombot $argstring
    }
    "netupdate" {
      if {!$nb_nudisable} {
        nb_netupdate $frombot $argstring
      }
    }
    "rnetupdate" {
      if {!$nb_nudisable} {
        nb_rnetupdate $frombot $argstring
      }
    }
    "autopass" {
      nb_autopass $frombot $argstring
    }
    "broadcast" {
      nb_broadcast $frombot $argstring
    }
    "autopass" {
      nb_autopass $frombot $argstring
    }
    "mservers" {
      ms_mservers $frombot $argstring
    }
    "rmservers" {
      ms_rmservers $frombot $argstring
    }
    "sl_lock" {
      nb_sl_lock $frombot $argstring
    }
    "default" {
      putlog "netbots: invalid command '$command' from $frombot"
    }
  }
}

proc nb_checkowner {hand idx} {
  global nb_owner owner
  regsub -all -- "," $owner "" olist
  if {$nb_owner && [lsearch -exact [stl [split $olist]] [stl $hand]] == -1} {
    putidx $idx "What?  You need '.help'"
    return 0
  }
  return 1
}

proc nb_randpass {} {
  set l [expr 8 + [rand 4]]
  for {set x 0} {$x < $l} {incr x} {
    append randpass [string index "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890" [rand 62]]
  }
  return $randpass
}

proc nb_duration {connected} {
  # This proc is based on that used in Bass's Seen script (http://bseen.tclslave.net)
  set years 0
  set days 0
  set hours 0
  set mins 0
  set time $connected
  if {$time < 60} {
    return "< 1 min"
  }
  if {$time >= 31536000} {
    set years [expr int([expr $time/31536000])]
    set time [expr $time - [expr 31536000*$years]]
  }
  if {$time >= 86400} {
    set days [expr int([expr $time/86400])]
    set time [expr $time - [expr 86400*$days]]
  }
  if {$time >= 3600} {
    set hours [expr int([expr $time/3600])]
    set time [expr $time - [expr 3600*$hours]]
  }
  if {$time >= 60} {
    set mins [expr int([expr $time/60])]
  }
  if {$years == 0} {
    set output ""
  } elseif {$years == 1} {
    set output "1 yr,"
  } else {
    set output "$years yrs,"
  }
  if {$days == 1} {
    lappend output "1 day,"
  } elseif {$days > 1} {
    lappend output "$days days,"
  }
  if {$hours == 1} {
    lappend output "1 hr,"
  } elseif {$hours > 1} {
    lappend output "$hours hrs,"
  }
  if {$mins == 1} {
    lappend output "1 min"
  } elseif {$mins > 1} {
    lappend output "$mins mins"
  }
  return [string trimright [join $output] ", "]
}

proc nb_onchan {nick chan} {
  if {[onchan $nick $chan] && ![onchansplit $nick $chan]} {
    return 1
  } else {
    return 0
  }
}

if {![info exists botnet-nick] || ${botnet-nick} == ""} {
  set botnet-nick $nick
}

if {[info exists nb_set]} {
  foreach nb_sbotset [array names nb_set] {
    set nb_sbots [lindex [split $nb_sbotset !] 0]
    set nb_ssetting [lindex [split $nb_sbotset !] 1]
    set nb_svalue $nb_set($nb_sbotset)
    if {[lsearch -exact [split [stl $nb_sbots] ,] [stl ${botnet-nick}]] != -1} {
      set $nb_ssetting $nb_svalue
    }
    unset nb_sbots
    unset nb_ssetting
    unset nb_svalue
  }
  unset nb_sbotset
}

if {![info exists nb_control]} {
  set nb_control $nb_defctrl
}

if {![info exists nb_getting]} {
  set nb_getting 0
}
if {[info exists nb_sending]} {
  unset nb_sending
}
set nb_script [info script]
set nb_tmpfile "nbtransfer.tmp"
set nb_ttmpfile "nbtmp.tmp"

if {![info exists nb_tmin]} {
  set nb_tmin [expr [rand 9] + 1]
}
if {![info exists nb_thour]} {
  set nb_thour [rand 24]
  if {[string length $nb_thour] == 1} {
    set nb_thour 0$nb_thour
  }
}
catch {unbind time - "2$nb_bindtime 0$nb_bindtime * * *" nb_update}
bind time - "2$nb_tmin $nb_thour * * *" nb_update
catch {unbind time - "1$nb_bindtime 0$nb_bindtime * * *" nb_tautopass}
bind time - "1$nb_tmin $nb_thour * * *" nb_tautopass
if {!$nb_autopass || $nb_flag == "b" || $nb_flag == "all"} {
  unbind time - "1$nb_tmin $nb_thour * * *" nb_tautopass
}
catch {unbind bot - nb_netbots nb_netbots}
catch {unbind bot - nb_netinfo nb_netinfo}
catch {unbind bot - nb_rnetinfo nb_rnetinfo}
catch {unbind bot - nb_netshell nb_netshell}
catch {unbind bot - nb_rnetshell nb_rnetshell}
catch {unbind bot - nb_netserv nb_netserv}
catch {unbind bot - nb_rnetserv nb_rnetserv}
catch {unbind bot - nb_netpass nb_netpass}
catch {unbind bot - nb_rnetpass nb_rnetpass}
catch {unbind bot - nb_netsave nb_netsave}
catch {unbind bot - nb_nethash nb_nethash}
catch {unbind bot - nb_netsay nb_netsay}
catch {unbind bot - nb_netact nb_netact}
catch {unbind bot - nb_netnotc nb_netnotc}
catch {unbind bot - nb_netjoin nb_netjoin}
catch {unbind bot - nb_netpart nb_netpart}
catch {unbind bot - nb_netchanset nb_netchanset}
catch {unbind bot - nb_netcycle nb_netcycle}
catch {unbind bot - nb_netupdate nb_netupdate}
catch {unbind bot - nb_rnetupdate nb_rnetupdate}
catch {unbind bot - nb_autopass nb_autopass}
catch {unbind bot - nb_broadcast nb_broadcast}
bind bot - nb nb_gotcmd
bind dcc n nethelp nb_dccnethelp
bind dcc n netbots nb_dccnetbots
bind dcc n netcontrol nb_dccnetcontrol
bind dcc n netinfo nb_dccnetinfo
bind dcc n netshell nb_dccnetshell
bind dcc n netserv nb_dccnetserv
bind dcc n netpass nb_dccnetpass
bind dcc n netsave nb_dccnetsave
bind dcc n nethash nb_dccnethash
bind dcc n netsay nb_dccnetsay
bind dcc n netact nb_dccnetact
bind dcc n netnotice nb_dccnetnotc
bind dcc n netdump nb_dccnetdump
bind dcc n netjoin nb_dccnetjoin
bind dcc n netpart nb_dccnetpart
bind dcc n netchanset nb_dccnetchanset
bind dcc n netcycle nb_dccnetcycle
bind dcc n netupdate nb_dccnetupdate
if {$nb_nudisable} {
  unbind dcc n netupdate nb_dccnetupdate
}
bind chon - * nb_chon
if {$numversion >= 1032800} {
  bind evnt - sighup nb_sighup
  bind evnt - sigterm nb_sigterm
}
bind raw - 001 nb_svconnect
bind raw - 465 nb_svkline


# aidle.tcl

if {$nb_component(aidle)} {
proc ai_start {} {
  global ai_time ai_uidle
  if {$ai_uidle} {
    if {[string match *ai_sendmsg* [utimers]]} {return 0}
    utimer [expr 140 + [rand 40]] ai_sendmsg
  } else {
    if {[string match *ai_sendmsg* [timers]]} {return 0}
    timer [expr [rand $ai_time] + 1] ai_sendmsg
  }
}

proc ai_sendmsg {} {
  global ai_chan ai_msgs ai_time ai_uidle
  if {[validchan $ai_chan] && [botonchan $ai_chan]} {
    puthelp "PRIVMSG $ai_chan :[lindex $ai_msgs [rand [llength $ai_msgs]]]"
  }
  if {$ai_uidle} {
    utimer [expr 140 + [rand 40]] ai_sendmsg
  } else {
    timer [expr [rand $ai_time] + 1] ai_sendmsg
  }
}

set ai_chan [stl $ai_chan]

ai_start
}


# botnetop.tcl

if {$nb_component(botnetop)} {
proc bop_jointmr {nick uhost hand chan} {
  global bop_delay botnick
  if {$nick == $botnick} {return 0}
  if {![matchattr $hand b] || ![matchattr $hand o|o $chan] || [matchattr $hand d|d $chan]} {return 0}
  foreach utimer [utimers] {
    if {[lindex $utimer 1] == "bop_askbot $hand $chan"} {return 0}
  }
  if {!$bop_delay} {
    utimer 5 "bop_askbot [split $hand] [split $chan]"
  } else {
    utimer [expr [rand $bop_delay] + 5] "bop_askbot [split $hand] [split $chan]"
  }
}

proc bop_linkop {bot via} {
  foreach chan [channels] {
    if {![botonchan $chan]} {continue}
    if {[botisop $chan]} {continue}
    bop_reqop $chan
  }
}

proc bop_reqop {chan} {
  global botnick
  if {[bots] == ""} {return 0}
  set chan $chan
  foreach bot [bots] {
    if {![matchattr $bot b] || ![matchattr $bot o|o $chan]} {continue}
    putbot $bot "reqops $chan $botnick"
  }
}

proc bop_reqtmr {frombot cmd arg} {
  global bop_delay
  set chan [slindex $arg 0]
  set fromnick [slindex $arg 1]
  if {![validchan $chan]} {return 0}
  if {![matchattr $frombot b] || ![matchattr $frombot o|o $chan] || [matchattr $frombot d|d $chan]} {return 0}
  foreach utimer [utimers] {
    if {[lindex $utimer 1] == "bop_askbot $frombot $chan"} {return 0}
  }
  if {!$bop_delay} {
    utimer 5 "bop_askbot [split $frombot] [split $chan]"
  } else {
    utimer [expr [rand $bop_delay] + 5] "bop_askbot [split $frombot] [split $chan]"
  }
}

proc bop_askbot {hand chan} {
  global botnick
  if {![validchan $chan]} {return 0}
  if {![botonchan $chan]} {return 0}
  if {![botisop $chan]} {return 0}
  if {![matchattr $hand b] || ![matchattr $hand o|o $chan] || [matchattr $hand d|d $chan]} {return 0}
  if {![islinked $hand]} {return 0}
  putbot $hand "doyawantops $chan $botnick"
}

proc bop_doiwantops {frombot cmd arg} {
  global bop_log bop_maxreq bop_opreqs botname botnick
  set chan [slindex $arg 0]
  set fromnick [slindex $arg 1]
  if {![validchan $chan]} {return 0}
  if {$bop_maxreq != 0 && $bop_opreqs([stl $chan]) >= $bop_maxreq} {return 0}
  if {![botonchan $chan]} {return 0}
  if {[botisop $chan]} {return 0}
  if {![nb_onchan $fromnick $chan]} {return 0}
  if {![isop $fromnick $chan]} {return 0}
  if {![matchattr [nick2hand $fromnick $chan] o|o $chan]} {return 0}
  if {![islinked $frombot]} {return 0}
  putbot $frombot "yesiwantops $chan $botnick [string trimleft [lindex [split $botname !] 1] ~]"
  incr bop_opreqs([stl $chan])
  if {$bop_maxreq != 0} {
    foreach utimer [utimers] {
      if {[string match "set bop_opreqs([stl $chan]) 0" [lindex $utimer 1]]} {
        killutimer [lindex $utimer 2]
      }
    }
    utimer 30 "set bop_opreqs([stl [split $chan]]) 0"
  }
  if {$bop_log >= 2} {
    putlog "botnetop: requested ops from $frombot on $chan"
  }
}

proc bop_botwantsops {frombot cmd arg} {
  global bop_addhost bop_log
  set chan [slindex $arg 0]
  set fromnick [slindex $arg 1]
  set fromhost [slindex $arg 2]
  if {![botonchan $chan]} {return 0}
  if {![botisop $chan]} {return 0}
  if {![nb_onchan $fromnick $chan]} {return 0}
  if {[isop $fromnick $chan]} {return 0}
  if {![matchattr $frombot b] || ![matchattr $frombot o|o $chan] || [matchattr $frombot d|d $chan]} {return 0}
  if {$fromhost != "" && ![string match $fromhost [string trimleft [getchanhost $fromnick $chan] ~]]} {return 0}
  if {![matchattr [nick2hand $fromnick $chan] o|o $chan]} {
    if {$fromhost != "" && $bop_addhost} {
      set host *![getchanhost $fromnick $chan]
      setuser $frombot HOSTS $host
      putlog "botnetop: added host $host to $frombot"
    } else {
      return 0
    }
  }
  pushmode $chan +o $fromnick
  if {$bop_log >= 2} {
    if {$fromnick != $frombot} {
      putlog "botnetop: gave ops to $frombot (using nick $fromnick) on $chan"
    } else {
      putlog "botnetop: gave ops to $frombot on $chan"
    }
  }
}

proc bop_letmein {needthis chan} {
  global botname botnick bop_log bop_needk bop_needi bop_needl bop_needu
  if {[bots] == ""} {return 0}
  if {[botonchan $chan]} {return 0}
  switch -exact -- $needthis {
    "needkey" {
      if {$bop_needk([stl $chan])} {return 0}
      set reqlist ""
      foreach bot [bots] {
        if {![matchattr $bot o|o $chan]} {continue}
        putbot $bot "wantkey $chan $botnick"
        lappend reqlist $bot
      }
      if {$reqlist != ""} {
        regsub -all -- " " [join $reqlist] ", " reqlist
        if {$bop_log >= 1} {
          putlog "botnetop: requested key for $chan from $reqlist"
        }
      }
      set bop_needk([stl $chan]) 1
      utimer 30 "set bop_needk([stl [split $chan]]) 0"
    }
    "needinvite" {
      if {$bop_needi([stl $chan])} {return 0}
      set reqlist ""
      foreach bot [bots] {
        if {![matchattr $bot o|o $chan]} {continue}
        putbot $bot "wantinvite $chan $botnick"
        lappend reqlist $bot
      }
      if {$reqlist != ""} {
        regsub -all -- " " [join $reqlist] ", " reqlist
        if {$bop_log >= 1} {
          putlog "botnetop: requested invite to $chan from $reqlist"
        }
      }
      set bop_needi([stl $chan]) 1
      utimer 30 "set bop_needi([stl [split $chan]]) 0"
    }
    "needlimit" {
      if {$bop_needl([stl $chan])} {return 0}
      set reqlist ""
      foreach bot [bots] {
        if {![matchattr $bot o|o $chan]} {continue}
        putbot $bot "wantlimit $chan $botnick"
        lappend reqlist $bot
      }
      if {$reqlist != ""} {
        regsub -all -- " " [join $reqlist] ", " reqlist
        if {$bop_log >= 1} {
          putlog "botnetop: requested limit raise on $chan from $reqlist"
        }
      }
      set bop_needl([stl $chan]) 1
      utimer 30 "set bop_needl([stl [split $chan]]) 0"
    }
    "needunban" {
      if {$bop_needu([stl $chan])} {return 0}
      set reqlist ""
      foreach bot [bots] {
        if {![matchattr $bot o|o $chan]} {continue}
        putbot $bot "wantunban $chan $botnick $botname"
        lappend reqlist $bot
      }
      if {$reqlist != ""} {
        regsub -all -- " " [join $reqlist] ", " reqlist
        if {$bop_log >= 1} {
          putlog "botnetop: requested unban on $chan from $reqlist"
        }
      }
      set bop_needu([stl $chan]) 1
      utimer 30 "set bop_needu([stl [split $chan]]) 0"
    }
  }
}

proc bop_botwantsin {frombot cmd arg} {
  global bop_log
  set chan [slindex $arg 0]
  set fromnick [slindex $arg 1]
  if {![validchan $chan]} {return 0}
  if {![botisop $chan]} {return 0}
  if {![matchattr $frombot b] || ![matchattr $frombot o|o $chan]} {return 0}
  switch -exact -- $cmd {
    "wantkey" {
      if {[string match *k* [lindex [getchanmode $chan] 0]]} {
        putbot $frombot "thekey $chan [lindex [getchanmode $chan] 1]"
        if {$bop_log >= 1} {
          putlog "botnetop: gave key for $chan to $frombot"
        }
      }
    }
    "wantinvite" {
      putserv "INVITE $fromnick $chan"
      if {$bop_log >= 1} {
        if {$fromnick != $frombot} {
          putlog "botnetop: invited $frombot (using nick $fromnick) to $chan"
        } else {
          putlog "botnetop: invited $frombot to $chan"
        }
      }
    }
    "wantlimit" {
      pushmode $chan +l [expr [llength [chanlist $chan]] + 1]
      if {$bop_log >= 1} {
        putlog "botnetop: raised limit on $chan as requested by $frombot"
      }
    }
    "wantunban" {
      set fromhost [slindex $arg 2]
      foreach ban [chanbans $chan] {
        if {[string match [stl [lindex $ban 0]] [stl $fromhost]]} {
          pushmode $chan -b [lindex $ban 0]
          if {$bop_log >= 1} {
            putlog "botnetop: unbanned $frombot on $chan"
          }
        }
      }
    }
  }
}

proc bop_joinkey {frombot cmd arg} {
  global bop_kjoin
  set chan [slindex $arg 0]
  set key [slindex $arg 1]
  if {[botonchan $chan] || $bop_kjoin([stl $chan])} {return 0}
  putserv "JOIN $chan $key"
  set bop_kjoin([stl $chan]) 1
  utimer 10 "set bop_kjoin([stl [split $chan]]) 0"
}

proc bop_checkop {nick uhost hand chan mode opped} {
  global botnick
  if {$mode == "+o" && [stl $nick] == [stl $botnick] && [stl $opped] != [stl $botnick] && ![matchattr [nick2hand $opped $chan] o|o $chan]} {
    pushmode $chan -o $opped
    putlog "botnetop: opped non +o user $opped on $chan - reversing."
    nb_sendcmd * "broadcast botnetop: opped non +o user $opped on $chan - reversing."
  }
}

proc bop_setneed {} {
  global bop_kjoin bop_needk bop_needi bop_needl bop_needu bop_opreqs
  foreach chan [stl [channels]] {
    if {[botonchan $chan]} {continue}
    channel set $chan need-op "bop_reqop [split $chan]"
    channel set $chan need-key "bop_letmein needkey [split $chan]"
    channel set $chan need-invite "bop_letmein needinvite [split $chan]"
    channel set $chan need-limit "bop_letmein needlimit [split $chan]"
    channel set $chan need-unban "bop_letmein needunban [split $chan]"
    set bop_opreqs($chan) 0
    set bop_needk($chan) 0
    set bop_kjoin($chan) 0
    set bop_needi($chan) 0
    set bop_needl($chan) 0
    set bop_needu($chan) 0
  }
  if {![string match *bop_setneed* [timers]]} {
    timer 5 bop_setneed
  }
}

proc bop_setneedjoin {nick uhost hand chan} {
  global botnick bop_kjoin bop_needk bop_needi bop_needl bop_needu bop_opreqs
  if {$nick != $botnick} {return 0}
  set chan [stl $chan]
  channel set $chan need-op "bop_reqop [split $chan]"
  channel set $chan need-key "bop_letmein needkey [split $chan]"
  channel set $chan need-invite "bop_letmein needinvite [split $chan]"
  channel set $chan need-limit "bop_letmein needlimit [split $chan]"
  channel set $chan need-unban "bop_letmein needunban [split $chan]"
  set bop_opreqs($chan) 0
  set bop_needk($chan) 0
  set bop_kjoin($chan) 0
  set bop_needi($chan) 0
  set bop_needl($chan) 0
  set bop_needu($chan) 0
}

if {![string match *bop_setneed* [utimers]]} {
  utimer 2 bop_setneed
}

bind link - * bop_linkop
if {!$bop_linkop} {
  unbind link - * bop_linkop
}
bind mode - * bop_checkop
if {!$bop_checkop} {
  unbind mode - * bop_checkop
}
bind bot - doyawantops bop_doiwantops
bind bot - yesiwantops bop_botwantsops
bind bot - reqops bop_reqtmr
bind bot - wantkey bop_botwantsin
bind bot - wantinvite bop_botwantsin
bind bot - wantlimit bop_botwantsin
bind bot - wantunban bop_botwantsin
bind bot - thekey bop_joinkey
bind join b * bop_jointmr
bind join - * bop_setneedjoin
}


# chanlimit.tcl

if {$nb_component(chanlimit)} {
proc cl_dolimit {} {
  global cl_chans cl_echans cl_limit cl_grace cl_timer
  foreach chan [stl [channels]] {
    if {$cl_chans != ""} {
      if {[lsearch -exact [split $cl_chans] $chan] == -1} {continue}
    }
    if {$cl_echans != ""} {
      if {[lsearch -exact [split $cl_echans] $chan] != -1} {continue}
    }
    if {![botonchan $chan] || ![botisop $chan]} {continue}
    set numusers [llength [chanlist $chan]]
    set newlimit [expr $numusers + $cl_limit]
    if {[string match *l* [lindex [getchanmode $chan] 0]]} {
      set currlimit [string range [getchanmode $chan] [expr [string last " " [getchanmode $chan]] + 1] end]
    } else {
      set currlimit 0
    }
    if {$newlimit == $currlimit} {continue}
    if {$newlimit > $currlimit} {
      set difference [expr $newlimit - $currlimit]
    } elseif {$currlimit > $newlimit} {
      set difference [expr $currlimit - $newlimit]
    }
    if {$difference <= $cl_grace} {continue}
    pushmode $chan "+l" "$newlimit"
    flushmode $chan
    putlog "chanlimit: set +l $newlimit on $chan"
  }
  timer $cl_timer cl_dolimit
}

proc cl_dccdolimit {hand idx arg} {
  foreach timer [timers] {
    if {[string match *cl_dolimit* $timer]} {
      killtimer [lindex $timer 2]
    }
  }
  putidx $idx "Checking limits..."
  cl_dolimit
}

proc cl_dccstoplimit {hand idx arg} {
  foreach timer [timers] {
    if {[string match *cl_dolimit* $timer]} {
      killtimer [lindex $timer 2]
      putidx $idx "Limiting is now OFF."
      return 0
    }
  }
  putidx $idx "Limiting is already off."
}

proc cl_dccstartlimit {hand idx arg} {
  global cl_timer
  if {[string match *cl_dolimit* [timers]]} {
    putidx $idx "Limiting is already on."
    return 0
  }
  timer $cl_timer cl_dolimit
  putidx $idx "Limiting is now ON."
}

proc cl_startlimit {} {
  global cl_timer
  if {[string match *cl_dolimit* [timers]]} {return 0}
  timer $cl_timer cl_dolimit
}

set cl_chans [stl $cl_chans]
set cl_echans [stl $cl_echans]

cl_startlimit

bind dcc m|m dolimit cl_dccdolimit
bind dcc m|m stoplimit cl_dccstoplimit
bind dcc m|m startlimit cl_dccstartlimit
}


# extras.tcl

if {$nb_component(extras)} {
proc ex_chon {hand idx} {
  set partylist ""
  if {[matchattr $hand n]} {
    foreach partydude [whom *] {
      if {[lindex $partydude 0] == $hand} {continue}
      lappend partylist [lindex $partydude 0]@[lindex $partydude 1]
    }
    if {$partylist == ""} {
      putidx $idx " "
      putidx $idx "There are no other users on the botnet."
      putidx $idx " "
    } else {
      set partylist [join $partylist ", "]
      putidx $idx " "
      putidx $idx "Other users on the botnet: $partylist"
      putidx $idx " "
    }
  } else {
    foreach partydude [whom 0] {
      if {[lindex $partydude 0] == $hand} {continue}
      lappend partylist [lindex $partydude 0]@[lindex $partydude 1]
    }
    if {$partylist == ""} {
      putidx $idx " "
      putidx $idx "There are no other users on the party line."
      putidx $idx " "
    } else {
      set partylist [join $partylist ", "]
      putidx $idx " "
      putidx $idx "Other users on the party line: $partylist"
      putidx $idx " "
    }
  }
}

bind chon - * ex_chon
if {!$ex_chon} {
  unbind chon - * ex_chon
}

proc ex_cleanup {min hour day month year} {
  putlog "Checking for redundant files.."
  catch {exec ls -a} files
  foreach file $files {
    if {[string match .share* $file] || [string match .nfs* $file] || $file == "core"} {
      if {[catch {set filedate [file atime $file]}] == 1} {continue}
      if {[expr [unixtime] - $filedate] > 1800} {
        catch {exec rm $file}
        putlog "Deleted '$file'."
      }
    }
  }
}

catch {unbind time - "4$nb_bindtime 0$nb_bindtime * * *" ex_cleanup}
bind time - "4$nb_tmin $nb_thour * * *" ex_cleanup
if {!$ex_cleanup} {
  unbind time - "4$nb_tmin $nb_thour * * *" ex_cleanup
}

proc ex_clearbans {hand idx arg} {
  set chan [slindex $arg 0]
  set remove [slindex $arg 1]
  if {$chan == "all"} {
    set gcount 0
    set ccount 0
    foreach ban [banlist] {
      if {$remove != ""} {
        if {[stl [lindex $ban 5]] == [stl $remove]} {
          killban [lindex $ban 0]
          incr gcount
        }
      } else {
        killban [lindex $ban 0]
        incr gcount
      }
    }
    foreach banchan [channels] {
      foreach ban [banlist $banchan] {
        if {$remove != ""} {
          if {[stl [lindex $ban 5]] == [stl $remove]} {
            killchanban $banchan [lindex $ban 0]
            incr ccount
          }
        } else {
           killchanban $banchan [lindex $ban 0]
           incr ccount
        }
      }
    }
    if {$remove != ""} {
      putidx $idx "Removed $gcount global and $ccount channel bans set by $remove."
    } else {
      putidx $idx "Removed $gcount global and $ccount channel bans."
    }
  } elseif {$chan == "global"} {
    set count 0
    foreach ban [banlist] {
      if {$remove != ""} {
        if {[stl [lindex $ban 5]] == [stl $remove]} {
          killban [lindex $ban 0]
          incr count
        }
      } else {
        killban [lindex $ban 0]
        incr count
      }
    }
    if {$remove != ""} {
      putidx $idx "Removed $count global bans set by $remove."
    } else {
      putidx $idx "Removed $count global bans."
    }
  } elseif {[string index $chan 0] == "#"} {
    if {![validchan $chan]} {
      putidx $idx "$chan is not a valid channel."
    } else {
      set count 0
      foreach ban [banlist $chan] {
        if {$remove != ""} {
          if {[stl [lindex $ban 5]] == [stl $remove]} {
            killchanban $chan [lindex $ban 0]
            incr count
          }
        } else {
          killchanban $chan [lindex $ban 0]
          incr count
        }
      }
      if {$remove != ""} {
        putidx $idx "Removed $count $chan bans set by $remove."
      } else {
        putidx $idx "Removed $count $chan bans."
      }
    }
  } else {
    putidx $idx "Usage: .clearbans \[#channel/global/all\] \[creator\]"
  }
}

proc ex_clearignores {hand idx arg} {
  set remove [slindex $arg 0]
  set count 0
  foreach ignore [ignorelist] {
    if {$remove != ""} {
      if {[stl [lindex $ignore 4]] == [stl $remove]} {
        killignore [lindex $ignore 0]
        incr count
      }
    } else {
      killignore [lindex $ignore 0]
      incr count
    }
  }
  if {$remove != ""} {
    putidx $idx "Removed $count ignores set by $remove."
  } else {
    putidx $idx "Removed $count ignores."
  }
}

bind dcc n clearbans ex_clearbans
bind dcc n clearignores ex_clearignores
if {!$ex_clearbans} {
  unbind dcc n clearbans ex_clearbans
  unbind dcc n clearignores ex_clearignores
}

proc ex_sendlog {hand idx arg} {
  set nick [slindex $arg 0]
  set file [slindex $arg 1]
  if {$nick == ""} {
    set loglist ""
    foreach log [logfile] {
      set logname [slindex $log 2]
      if {[file exists $logname]} {
        set logsize [expr [file size $logname] / 1024]
        if {$logsize < 1} {
          set logsize 1
        }
        lappend loglist "$logname ($logsize K)"
      }
      if {[file exists $logname.yesterday]} {
        set logsize [expr [file size $logname.yesterday] / 1024]
        if {$logsize < 1} {
          set logsize 1
        }
        lappend loglist "$logname.yesterday ($logsize K)"
      }
    }
    if {$loglist == ""} {
      putidx $idx "There are no logs to send."
    } else {
      putidx $idx "Log files:"
      foreach log $loglist {
        putidx $idx $log
      }
    }
  } else {
    if {$file == ""} {
      putidx $idx "Usage: .sendlog \[nick <logfile>\]"
    } else {
      switch -exact -- [dccsend $file $nick] {
        0 {
          putidx $idx "Sending $file to $nick"
        }
        1 {
          putidx $idx "Error: can't send $file (too many connections)"
        }
        2 {
          putidx $idx "Error: can't send $file (can't open socket)"
        }
        3 {
          putidx $idx "File '$file' does not exist."
        }
        4 {
          putidx $idx "Error: can't send $file ($nick has too many transfers)"
        }
      }
    }
  }
}

bind dcc n sendlog ex_sendlog
if {!$ex_sendlog} {
  unbind dcc n sendlog ex_sendlog
}
}


# mainserver.tcl

if {$nb_component(mainserver)} {
proc ms_chkserver {} {
  global ms_chan ms_chktime ms_mserver ms_needbot server
  set chan [stl $ms_chan]
  if {[stl [lindex [split $server :] 0]] != [stl [lindex [split $ms_mserver :] 0]]} {
    putlog "mainserver: I'm not on [lindex [split $ms_mserver :] 0] - checking to see if I can jump.."
    if {[validchan $chan] && [botonchan $chan]} {
      set foundbot 0
      foreach nick [chanlist $ms_chan] {
        set hand [nick2hand $nick $chan]
        if {[isop $nick $chan] && [matchattr $hand b] && [matchattr $hand o|o $chan] && ![onchansplit $nick $chan] && [islinked $hand]} {
          incr foundbot 1
          if {$foundbot == $ms_needbot} {
            putlog "mainserver: found $ms_needbot bots to reop me on rejoin - jumping to [lindex [split $ms_mserver :] 0]"
            jump [lindex [split $ms_mserver :] 0] [lindex [split $ms_mserver :] 1]
            utimer 60 ms_dblcheck
            return 0
          }
        }
      }
    }
    putlog "mainserver: I can't jump because there aren't $ms_needbot other bots to reop me when I rejoin my channels, will try again in $ms_chktime\
    minutes."
    timer $ms_chktime ms_chkserver
  } else {
    timer $ms_chktime ms_chkserver
  }
}

proc ms_dblcheck {} {
  global ms_chktime ms_failed ms_mserver ms_tryagn server
  if {[stl [lindex [split $server :] 0]] != [stl [lindex [split $ms_mserver :] 0]]} {
    putlog "mainserver: failed to connect to [lindex [split $ms_mserver :] 0] - will try once more in $ms_tryagn minutes."
    set ms_failed 1
    timer $ms_tryagn ms_tryagn
  } else {
    set ms_failed 0
    putlog "mainserver: successful jump to [lindex [split $ms_mserver :] 0] detected."
    timer $ms_chktime ms_chkserver
  }
}

proc ms_tryagn {} {
  global ms_chan ms_chktime ms_mserver ms_needbot ms_tryagn server
  set chan [stl $ms_chan]
  if {[stl [lindex [split $server :] 0]] != [stl [lindex [split $ms_mserver :] 0]]} {
    putlog "mainserver: failed to connect to [lindex [split $ms_mserver :] 0] $ms_tryagn minutes ago - trying once more.."
    if {[validchan $chan] && [botonchan $chan]} {
      set foundbot 0
      foreach nick [chanlist $ms_chan] {
        set hand [nick2hand $nick $chan]
        if {[isop $nick $chan] && [matchattr $hand b] && [matchattr $hand o|o $chan] && ![onchansplit $nick $chan] && [islinked $hand]} {
          incr foundbot 1
          if {$foundbot == $ms_needbot} {
            putlog "mainserver: found $ms_needbot bots to reop me on rejoin - jumping to [lindex [split $ms_mserver :] 0]"
            jump [lindex [split $ms_mserver :] 0] [lindex [split $ms_mserver :] 1]
            utimer 60 ms_forgetit
            return 0
          }
        }
      }
    }
    putlog "mainserver: I can't jump because there aren't $ms_needbot other bots to reop me when I rejoin my channels - will try again in $ms_tryagn\
    minutes."
    timer $ms_tryagn ms_tryagn
  } else {
    set ms_failed 0
    timer $ms_chktime ms_chkserver
  }
}

proc ms_forgetit {} {
  global ms_chktime ms_failed ms_loaded ms_mserver ms_note server
  if {[stl [lindex [split $server :] 0]] != [stl [lindex [split $ms_mserver :] 0]]} {
    putlog "mainserver: failed to connect to [lindex [split $ms_mserver :] 0] on second attempt - sending note to inform [join [split\
    $ms_note] ", "]"
    set ms_failed 2
    set ms_loaded 0
    foreach recipient [split $ms_note] {
      if {[validuser $recipient]} {
        sendnote MAINSERVER $recipient "Failed to connect to [lindex [split $ms_mserver :] 0] on second attempt."
      }
    }
  } else {
    set ms_failed 0
    putlog "mainserver: successful jump to [lindex [split $ms_mserver :] 0] detected."
    timer $ms_chktime ms_chkserver
  }
}

proc dcc_mserver {hand idx arg} {
  global default-port ms_failed ms_mserver server
  putcmdlog "#$hand# mserver $arg"
  if {$arg != ""} {
    set serv [slindex $arg 0]
    set port [slindex $arg 1]
    set ms_mserver [join "$serv $port" :]
    putidx $idx "Temporarily changed main server to $ms_mserver"
    return 0
  }
  putidx $idx "mainserver.tcl by slennox"
  putidx $idx "Use .mserver <server> <port> to temporarily change main server."
  putidx $idx "This bot's main server is: $ms_mserver"
  if {[stl $server] == [stl $ms_mserver]} {
    putidx $idx "Connected to my main server :-)"
  } elseif {$server == ""} {
    putidx $idx "Not connected to a server."
  } else {
    putidx $idx "Connected to: $server"
  }
  if {$ms_failed==1} {
    putidx $idx "Jump status: failed first attempt to connect to [lindex [split $ms_mserver :] 0]"
  }
  if {$ms_failed==2} {
    putidx $idx "Jump status: failed both attempts to connect to [lindex [split $ms_mserver :] 0]"
  }
  foreach timer [timers] {
    if {[lindex $timer 1] != "ms_chkserver"} {continue}
    putidx $idx "Timer status: [lindex $timer 0] minutes until the next server check."
    set timeron 1
  }
  foreach timer [timers] {
    if {[lindex $timer 1] != "ms_tryagn"} {continue}
    putidx $idx "Timer status: [lindex $timer 0] minutes until the second attempt to connect to [lindex [split $ms_mserver :] 0]"
    set timeron 1
  }
  foreach timer [utimers] {
    if {[lindex $timer 1] != "ms_dblcheck"} {continue}
    putidx $idx "Timer status: waiting to check if attempt to jump to [lindex [split $ms_mserver :] 0] was successful.."
    set timeron 1
  }
  foreach timer [utimers] {
    if {[lindex $timer 1] != "ms_forgetit"} {continue}
    putidx $idx "Timer status: waiting to check if second attempt to jump to [lindex [split $ms_mserver :] 0] was successful.."
    set timeron 1
  }
  if {![info exists timeron]} {
    putidx $idx "Timer status: server checking not active - use .msreset to restart the timer."
  }
}

proc ms_dccmservers {hand idx arg} {
  global botnet-nick ms_mserver server whoreq
  putcmdlog "#$hand# mservers $arg"
  if {![ms_timer]} {
    if {$server == ""} {
      putidx $idx "${botnet-nick} is not connected to a server (main server is $ms_mserver) \[timer inactive\]"
    } elseif {[stl $server] == [stl $ms_mserver]} {
      putidx $idx "${botnet-nick} is connected to $server (its main server) \[timer inactive\]"
    } else {
      putidx $idx "${botnet-nick} is connected to $server (main server is $ms_mserver) \[timer inactive\]"
    }
  } else {
    if {$server == ""} {
      putidx $idx "${botnet-nick} is not connected to a server (main server is $ms_mserver)"
    } elseif {[stl $server] == [stl $ms_mserver]} {
      putidx $idx "${botnet-nick} is connected to $server (its main server)"
    } else {
      putidx $idx "${botnet-nick} is connected to $server (main server is $ms_mserver)"
    }
  }
  nb_sendcmd * "mservers $idx"
}

proc ms_mservers {frombot arg} {
  global botnick ms_mserver server
  if {$server == ""} {
    set currserver "none"
  } else {
    set currserver $server
  }
  if {![ms_timer]} {
    nb_sendcmd $frombot "rmservers [slindex $arg 0] $currserver $ms_mserver tmroff"
  } else {
    nb_sendcmd $frombot "rmservers [slindex $arg 0] $currserver $ms_mserver"
  }
}

proc ms_rmservers {frombot arg} {
  set idx [slindex $arg 0]
  set serveron [slindex $arg 1]
  set servermain [slindex $arg 2]
  if {[slindex $arg 3] == "tmroff"} {
    if {$serveron == "none"} {
      putidx $idx "$frombot is not connected to a server (main server is $servermain) \[timer inactive\]"
    } elseif {[stl $serveron] == [stl $servermain]} {
      putidx $idx "$frombot is connected to $serveron (its main server) \[timer inactive\]"
    } else {
      putidx $idx "$frombot is connected to $serveron (main server is $servermain) \[timer inactive\]"
    }
  } else {
    if {$serveron == "none"} {
      putidx $idx "$frombot is not connected to a server (main server is $servermain)"
    } elseif {[stl $serveron] == [stl $servermain]} {
      putidx $idx "$frombot is connected to $serveron (its main server)"
    } else {
      putidx $idx "$frombot is connected to $serveron (main server is $servermain)"
    }
  }
}

proc dcc_msreset {hand idx arg} {
  global ms_chktime ms_failed ms_loaded ms_mserver
  putcmdlog "#$hand# msreset $arg"
  if {$ms_loaded} {
    putidx $idx "Server check is already active."
  } else {
    set ms_loaded 1
    set ms_failed 0
    timer $ms_chktime ms_chkserver
    putidx $idx "Reset mainserver.tcl timer, will resume checking to make sure I'm on [lindex [split $ms_mserver :] 0]"
  }
}

proc ms_timer {} {
  set timers [timers]
  set utimers [utimers]
  if {![string match "*ms_chkserver*" $timers] && ![string match "*ms_tryagn*" $timers] && ![string match "*ms_dblcheck*" $utimers] && ![string\
  match "*ms_forgetit*" $utimers]} {
    return 0
  } else {
    return 1
  }
}

if {![info exists ms_loaded]} {
  set ms_loaded 1
  set ms_failed 0
  timer $ms_chktime ms_chkserver
}

proc ms_randomise {} {
  global servers ms_mserver ms_servers
  set list $ms_servers
  set randlist $ms_mserver
  while {[llength $list] > 0} {
    set random [rand [llength $list]]
    lappend randlist [lindex $list $random]
    set list [lreplace $list $random $random]
  }
  set servers $randlist
}

set strict-servernames 0
ms_randomise

bind dcc n mserver dcc_mserver
catch {unbind dcc n mservers dcc_mservers}
bind dcc n mservers ms_dccmservers
bind dcc n msreset dcc_msreset
}


# masskick.tcl

if {$nb_component(masskick)} {
proc mk_masskick {chan kickmsg} {
  global botnick mk_kicks mk_reason
  if {$kickmsg == ""} {
    set kickmsg $mk_reason
  }
  putserv "MODE $chan +i"
  set list [chanlist $chan]
  set randlist ""
  while {[llength $list] > 0} {
    set random [rand [llength $list]]
    lappend randlist [lindex $list $random]
    set list [lreplace $list $random $random]
  }
  set chanlist $randlist
  set klist ""
  foreach knick $chanlist {
    if {$knick == $botnick || [isop $knick $chan] || [isvoice $knick $chan] || [matchattr [nick2hand $knick $chan] fov|fov $chan]} {continue}
    lappend klist $knick
    if {[llength $klist] >= $mk_kicks} {
      set klist [join $klist ","]
      putserv "KICK $chan $klist :$kickmsg"
      unset klist
    }
  }
  if {[info exists klist]} {
    set klist [join $klist ","]
    putserv "KICK $chan $klist :$kickmsg"
    unset klist
  }
}

proc mk_pub {nick uhost hand chan arg} {
  global botnick
  if {![isop $nick $chan] || ![botisop $chan]} {return 0}
  set kickbot [slindex [stl $arg] 0]
  if {$kickbot == ""} {
    puthelp "NOTICE $nick :You must specify a bot nick/handle to do the mass kick."
    return 0
  }
  if {$kickbot != [stl $botnick] && ![isbotnetnick $kickbot] && $kickbot != "*"} {return 0}
  putcmdlog "masskick: mass kick requested by $hand on $chan."
  mk_masskick $chan [join [lrange [split $arg] 1 end]]
}

proc mk_dcc {hand idx arg} {
  set chan [slindex $arg 0]
  if {$chan == ""} {
    putidx $idx "You must specify a channel."
    return 0
  } elseif {![validchan $chan]} {
    putidx $idx "No such channel."
    return 0
  } elseif {![matchattr $hand o|o $chan]} {
    putidx $idx "You're not an op on $chan"
    return 0
  } elseif {![botonchan $chan]} {
    putidx $idx "I'm not on $chan"
    return 0
  } elseif {![botisop $chan]} {
    putidx $idx "I'm not opped on $chan"
    return 0
  }
  putcmdlog "#$hand# mk $arg"
  mk_masskick $chan [join [lrange [split $arg] 1 end]]
}

bind pub o|o .mk mk_pub
bind dcc o|o mk mk_dcc
}


# nocycle.tcl

if {$nb_component(nocycle)} {
proc cy_check {from keyword arg} {
  global botnick cy_chans cy_gotnotc server
  if {$cy_gotnotc} {return 0}
  set arg [split $arg]
  set nick [lindex [split $from !] 0]
  if {![string match *.* $nick]} {return 0}
  set text [lrange $arg 1 end]
  if {![string match "*** Notice -- Due to a network split, you can not obtain channel operator status in a new channel at this time."\
  $text]} {return 0}
  set cy_gotnotc 1
  set opped ""
  set nopped ""
  foreach chan [stl [channels]] {
    if {![botonchan $chan]} {
      lappend nopped $chan
    } elseif {[isop $botnick $chan]} {
      lappend opped $chan
    } else {
      lappend nopped $chan
    }
  }
  if {$opped == ""} {
    putlog "nocycle: detected no_chanops_when_split on my current server ([lindex [split $server :] 0]). Not opped on any channels - jumping to next\
    server."
    jump
  } else {
    if {$nopped == ""} {return 0}
    foreach chan $nopped {
      if {[string match *-cycle* [channel info $chan]]} {continue}
      lappend cy_chans $chan
      channel set $chan -cycle
    }
    if {$cy_chans == ""} {return 0}
    set oplist [join $opped ", "]
    set noplist [join $cy_chans ", "]
    putlog "nocycle: detected no_chanops_when_split on my current server ([lindex [split $server :] 0]). Opped on $oplist - switched off cycle for\
    $noplist."
  }
}

proc cy_on {from keyword arg} {
  global cy_chans cy_gotnotc
  set cy_gotnotc 0
  if {$cy_chans == ""} {return 0}
  foreach chan $cy_chans {
    if {![validchan $chan]} {continue}
    channel set $chan +cycle
  }
  set cy_chans ""
}

if {![info exists cy_chans]} {
  set cy_chans ""
}
if {![info exists cy_gotnotc]} {
  set cy_gotnotc 0
}

bind raw - NOTICE cy_check
bind raw - 002 cy_on
}


# repeat.tcl

if {$nb_component(repeat)} {
proc rp_pubmsg {nick uhost hand chan text} {
  global botnick rp_bcount rp_bflood rp_breason rp_btime rp_kcount rp_kflood rp_kreason rp_scount rp_sflood rp_slength rp_sreason
  set uhost [stl $uhost]
  set chan [stl $chan]
  set text [stl $text]
  if {$nick == $botnick} {return 0}
  if {[matchattr $hand f|f $chan]} {return 0}
  if {![info exists rp_bcount($uhost:$chan:$text)]} {
    set rp_bcount($uhost:$chan:$text) 0
  }
  incr rp_bcount($uhost:$chan:$text)
  if {![info exists rp_kcount($uhost:$chan:$text)]} {
    set rp_kcount($uhost:$chan:$text) 0
  }
  incr rp_kcount($uhost:$chan:$text)
  if {[string length $text] > $rp_slength} {
    if {![info exists rp_scount($uhost:$chan:$text)]} {
      set rp_scount($uhost:$chan:$text) 0
    }
    incr rp_scount($uhost:$chan:$text)
  }
  if {$rp_bcount($uhost:$chan:$text) == [lindex $rp_bflood 0]} {
    if {[botisop $chan]} {
      putserv "KICK $chan $nick :$rp_breason"
    }
    set bmask *!*[stl [string range $uhost [string first @ $uhost] end]]
    newchanban $chan $bmask repeat $rp_breason $rp_btime
    return 0
  }
  if {$rp_kcount($uhost:$chan:$text) == [lindex $rp_kflood 0]} {
    rp_mhost $nick $uhost $chan
    if {[botisop $chan]} {
      putserv "KICK $chan $nick :$rp_kreason"
    }
    return 0
  }
  if {[info exists rp_scount($uhost:$chan:$text)]} {
    if {$rp_scount($uhost:$chan:$text) == [lindex $rp_sflood 0]} {
      rp_mhost $nick $uhost $chan
      if {[botisop $chan]} {
        putserv "KICK $chan $nick :$rp_sreason"
      }
      return 0
    }
  }
}

proc rp_pubact {nick uhost hand dest key arg} {
  rp_pubmsg $nick $uhost $hand $dest $arg
}

proc rp_pubnotc {from keyword arg} {
  set nick [lindex [split $from !] 0]
  set chan [stl [slindex $arg 0]]
  if {![validchan $chan] || ![onchan $nick $chan]} {return 0}
  set uhost [getchanhost $nick $chan]
  set hand [nick2hand $nick $chan]
  set text [join [lrange [split $arg] 1 end]]
  rp_pubmsg $nick $uhost $hand $chan $text
}

proc rp_mhost {nick uhost chan} {
  global rp_btime rp_mhosts rp_mreason rp_mtime
  set mhost [lindex [split $uhost @] 1]
  if {![info exists rp_mhosts($chan)]} {
    set rp_mhosts($chan) ""
  }
  set mlist $rp_mhosts($chan)
  if {[lsearch -exact $mlist $mhost] != -1} {
    set bmask *!*[stl [string range $uhost [string first @ $uhost] end]]
    newchanban $chan $bmask repeat $rp_mreason $rp_btime
  } else {
    lappend rp_mhosts($chan) $mhost
    utimer $rp_mtime "rp_mhostreset $chan"
  }
}

proc rp_mhostreset {chan} {
  global rp_mhosts
  set rp_mhosts($chan) [lrange rp_mhosts($chan) 1 end]
}

proc rp_kreset {} {
  global rp_kcount rp_kflood
  if {[info exists rp_kcount]} {
    unset rp_kcount
  }
  utimer [lindex $rp_kflood 1] rp_kreset
}

proc rp_breset {} {
  global rp_bcount rp_bflood
  if {[info exists rp_bcount]} {
    unset rp_bcount
  }
  utimer [lindex $rp_bflood 1] rp_breset
}

proc rp_sreset {} {
  global rp_scount rp_sflood
  if {[info exists rp_scount]} {
    unset rp_scount
  }
  utimer [lindex $rp_sflood 1] rp_sreset
}

set rp_utimers [utimers]
if {![string match *rp_kreset* $rp_utimers] && [lsearch -exact $rp_kflood 0] == -1} {
  global rp_kflood
  utimer [lindex $rp_kflood 1] rp_kreset
}
if {![string match *rp_breset* $rp_utimers] && [lsearch -exact $rp_bflood 0] == -1} {
  global rp_bflood
  utimer [lindex $rp_bflood 1] rp_breset
}
if {![string match *rp_sreset* $rp_utimers] && [lsearch -exact $rp_sflood 0] == -1} {
  global rp_sflood
  utimer [lindex $rp_sflood 1] rp_sreset
}
unset rp_utimers

set rp_kflood [split $rp_kflood :]
set rp_bflood [split $rp_bflood :]
set rp_sflood [split $rp_sflood :]

bind pubm - * rp_pubmsg
bind ctcp - ACTION rp_pubact
bind raw - NOTICE rp_pubnotc
}


# sentinel.tcl

if {$nb_component(sentinel)} {
proc sl_ctcp {nick uhost hand dest key arg} {
  set chan [stl $dest]
  global botnet-nick botnick sl_ban sl_bflooded sl_bcflood sl_bcqueue sl_ccbanhost sl_ccbannick sl_ccflood sl_ccqueue sl_flooded sl_locked sl_note
  if {[lsearch -exact $sl_ccflood 0] == -1 && [validchan $chan] && ![isop $nick $chan]} {
    if {$nick == $botnick} {return 0}
    if {$sl_ban != 0 && !$sl_locked($chan) && ![matchattr $hand f|f $chan]} {
      set bhost *!*[stl [string range $uhost [string first @ $uhost] end]]
      lappend sl_ccbannick($chan) $nick
      lappend sl_ccbanhost($chan) $bhost
      utimer [lindex $sl_ccflood 1] "sl_ccbanqueue [split $chan]"
    }
    if {$sl_flooded($chan)} {return 1}
    incr sl_ccqueue($chan)
    utimer [lindex $sl_ccflood 1] "sl_ccqueuereset [split $chan]"
    if {$sl_ccqueue($chan) >= [lindex $sl_ccflood 0]} {
      sl_lock $chan "CTCP flood" ${botnet-nick}
      return 1
    }
    if {$sl_bflooded} {return 1}
  } elseif {[lindex $sl_bcflood 0] != 0 && $dest == $botnick} {
    if {$sl_bflooded} {
      sl_ignore $uhost $hand "CTCP flooder"
      return 1
    }
    incr sl_bcqueue
    utimer [lindex $sl_bcflood 1] sl_bcqueuereset
    if {$sl_bcqueue >= [lindex $sl_bcflood 0]} {
      putlog "sentinel: CTCP flood detected on me! Stopped answering CTCPs temporarily."
      set sl_bflooded 1
      utimer [lindex $sl_bcflood 1] "set sl_bflooded 0"
      foreach recipient [split $sl_note] {
        if {[validuser $recipient]} {
          sendnote SENTINEL $recipient "Bot was CTCP flooded."
        }
      }
      nb_sendcmd * "broadcast sentinel: CTCP flood detected on me!"
      return 1
    }
    nb_sendcmd * "broadcast CTCP from $nick!$uhost: $key [string range $arg 0 150]"
  }

  global sl_bxsimul
  if {!$sl_bxsimul} {return 0}
  global sl_bxonestack
  if {$sl_bxonestack} {return 1}
  set sl_bxonestack 1
  utimer 2 "set sl_bxonestack 0"

  switch -exact -- $key {
    "CLIENTINFO" {
      set bxcmd [string toupper $arg]
      switch -exact -- $bxcmd {
        "" {putserv "NOTICE $nick :\001CLIENTINFO SED UTC ACTION DCC CDCC BDCC XDCC VERSION CLIENTINFO USERINFO ERRMSG FINGER TIME PING ECHO\
        INVITE WHOAMI OP OPS UNBAN IDENT XLINK UPTIME  :Use CLIENTINFO <COMMAND> to get more specific information\001"}
        "SED" {putserv "NOTICE $nick :\001CLIENTINFO SED contains simple_encrypted_data\001"}
        "UTC" {putserv "NOTICE $nick :\001CLIENTINFO UTC substitutes the local timezone\001"}
        "ACTION" {putserv "NOTICE $nick :\001CLIENTINFO ACTION contains action descriptions for atmosphere\001"}
        "DCC" {putserv "NOTICE $nick :\001CLIENTINFO DCC requests a direct_client_connection\001"}
        "CDCC" {putserv "NOTICE $nick :\001CLIENTINFO CDCC checks cdcc info for you\001"}
        "BDCC" {putserv "NOTICE $nick :\001CLIENTINFO BDCC checks cdcc info for you\001"}
        "XDCC" {putserv "NOTICE $nick :\001CLIENTINFO XDCC checks cdcc info for you\001"}
        "VERSION" {putserv "NOTICE $nick :\001CLIENTINFO VERSION shows client type, version and environment\001"}
        "CLIENTINFO" {putserv "NOTICE $nick :\001CLIENTINFO CLIENTINFO gives information about available CTCP commands\001"}
        "USERINFO" {putserv "NOTICE $nick :\001CLIENTINFO USERINFO returns user settable information\001"}
        "ERRMSG" {putserv "NOTICE $nick :\001CLIENTINFO ERRMSG returns error messages\001"}
        "FINGER" {putserv "NOTICE $nick :\001CLIENTINFO FINGER shows real name, login name and idle time of user\001"}
        "TIME" {putserv "NOTICE $nick :\001CLIENTINFO TIME tells you the time on the user's host\001"}
        "PING" {putserv "NOTICE $nick :\001CLIENTINFO PING returns the arguments it receives\001"}
        "ECHO" {putserv "NOTICE $nick :\001CLIENTINFO ECHO returns the arguments it receives\001"}
        "INVITE" {putserv "NOTICE $nick :\001CLIENTINFO INVITE invite to channel specified\001"}
        "WHOAMI" {putserv "NOTICE $nick :\001CLIENTINFO WHOAMI user list information\001"}
        "OP" {putserv "NOTICE $nick :\001CLIENTINFO OP ops the person if on userlist\001"}
        "OPS" {putserv "NOTICE $nick :\001CLIENTINFO OPS ops the person if on userlist\001"}
        "UNBAN" {putserv "NOTICE $nick :\001CLIENTINFO UNBAN unbans the person from channel\001"}
        "IDENT" {putserv "NOTICE $nick :\001CLIENTINFO IDENT change userhost of userlist\001"}
        "XLINK" {putserv "NOTICE $nick :\001CLIENTINFO XLINK x-filez rule\001"}
        "UPTIME" {putserv "NOTICE $nick :\001CLIENTINFO UPTIME my uptime\001"}
        "default" {putserv "NOTICE $nick :\001ERRMSG CLIENTINFO: $arg is not a valid function\001"}
      }
      return 1
    }
    "VERSION" {
      global sl_bxversion sl_bxsystem
      putserv "NOTICE $nick :\001VERSION \002BitchX-$sl_bxversion\002 by panasync \002-\002 $sl_bxsystem :\002 Keep it to yourself!\002\001"
      return 1
    }
    "USERINFO" {
      putserv "NOTICE $nick :\001USERINFO \001"
      return 1
    }
    "FINGER" {
      global realname sl_bxwhoami sl_bxmachine sl_bxjointime
      set idletime [expr [unixtime] - $sl_bxjointime]
      putserv "NOTICE $nick :\001FINGER $realname ($sl_bxwhoami@$sl_bxmachine) Idle $idletime seconds\001"
      return 1
    }
    "ECHO" {
      if {[validchan $chan]} {return 1}
      putserv "NOTICE $nick :\001ECHO [string range $arg 0 59]\001"
      return 1
    }
    "ERRMSG" {
      if {[validchan $chan]} {return 1}
      putserv "NOTICE $nick :\001ERRMSG [string range $arg 0 59]\001"
      return 1
    }
    "INVITE" {
      if {[llength $arg] == 0 || [validchan $chan]} {return 1}
      set chan [slindex $arg 0]
      if {[string trim [string index $chan 0] "#+&"] == ""} {
        if {[validchan $chan]} {
          putserv "NOTICE $nick :\002BitchX\002: Access Denied"
        } else {
          putserv "NOTICE $nick :\002BitchX\002: I'm not on that channel"
        }
      }
      return 1
    }
    "WHOAMI" {
      if {[validchan $chan]} {return 1}
      putserv "NOTICE $nick :\002BitchX\002: Access Denied"
      return 1
    }
    "OP" -
    "OPS" {
      if {[llength $arg] == 0 || [validchan $chan]} {return 1}
      set chan [slindex $arg 0]
      putserv "NOTICE $nick :\002BitchX\002: I'm not on $chan, or I'm not opped"
      return 1
    }
    "UNBAN" {
      if {[llength $arg] == 0 || [validchan $chan]} {return 1}
      set chan [slindex $arg 0]
      if {[validchan $chan]} {
        putserv "NOTICE $nick :\002BitchX\002: Access Denied"
      } else {
        putserv "NOTICE $nick :\002BitchX\002: I'm not on that channel"
      }
      return 1
    }
  }
}

proc sl_bmflood {nick uhost hand text} {
  global sl_bmflood sl_bflooded sl_bmqueue sl_note
  if {[lsearch -exact $sl_bmflood 0] != -1} {return 0}
  if {[matchattr $hand b] && [stl [lindex [split $text] 0]] == "go"} {return 0}
  if {$sl_bflooded} {
    sl_ignore $uhost $hand "MSG flooder"
    return 1
  }
  incr sl_bmqueue
  utimer [lindex $sl_bmflood 1] sl_bmqueuereset
  if {$sl_bmqueue >= [lindex $sl_bmflood 0]} {
    putlog "sentinel: MSG flood detected on me! Stopped answering MSGs temporarily."
    set sl_bflooded 1
    utimer [lindex $sl_bmflood 1] "set sl_bflooded 0"
    foreach recipient [split $sl_note] {
      if {[validuser $recipient]} {
        sendnote SENTINEL $recipient "Bot was MSG flooded."
      }
    }
    nb_sendcmd * "broadcast sentinel: MSG flood detected on me!"
    return 0
  }
  if {!$sl_bflooded} {
    nb_sendcmd * "broadcast MSG from $nick!$uhost: [slindex $text 0] .."
  }
}

proc sl_avflood {from keyword arg} {
  global botnet-nick botnick sl_ban sl_avbanhost sl_avbannick sl_avflood sl_avqueue sl_flooded sl_locked sl_txflood sl_txqueue
  set arg [split $arg]
  set nick [lindex [split $from !] 0]
  set text [join [lrange $arg 1 end]]
  if {$nick == $botnick} {return 0}
  if {$nick == "" || [string match *.* $nick]} {return 0}
  if {[lindex $arg 0] == $botnick} {return 0}
  set chan [stl [lindex $arg 0]]
  if {[validchan $chan]} {
    if {![onchan $nick $chan]} {return 0}
    if {[isop $nick $chan]} {return 0}
    if {!$sl_flooded($chan) && [lsearch -exact $sl_txflood 0] == -1} {
      incr sl_txqueue($chan)
      if {$sl_txqueue($chan) >= [lindex $sl_txflood 0]} {
        sl_lock $chan "TEXT flood" ${botnet-nick}
      }
    }
    if {[sl_checkaval $text] && [lsearch -exact $sl_avflood 0] == -1} {
      set uhost [getchanhost $nick $chan]
      set hand [nick2hand $nick $chan]
      if {$sl_ban != 0 && !$sl_locked($chan) && $nick != $botnick && ![matchattr $hand f|f $chan]} {
        set bhost *!*[stl [string range $uhost [string first @ $uhost] end]]
        lappend sl_avbannick($chan) $nick
        lappend sl_avbanhost($chan) $bhost
        utimer [lindex $sl_avflood 1] "sl_avbanqueue [split $chan]"
      }
      if {$sl_flooded($chan)} {return 0}
      incr sl_avqueue($chan)
      utimer [lindex $sl_avflood 1] "sl_avqueuereset [split $chan]"
      if {$sl_avqueue($chan) >= [lindex $sl_avflood 0]} {
        sl_lock $chan "AVALANCHE flood" ${botnet-nick}
      }
    }
  }
}

proc sl_checkaval {text} {
  if {[expr [regsub -all -- "\007" $text "" temp] + [regsub -all -- "\001" $temp "" temp]] >= 3} {return 1}
  return 0
}

proc sl_nkflood {nick uhost hand chan newnick} {
  global botnet-nick botnick sl_ban sl_banmax sl_flooded sl_globalban sl_locked sl_nickkick sl_nkbanhost sl_nkflood sl_nkflooding sl_nkqueue
  if {[lsearch -exact $sl_nkflood 0] != -1} {return 0}
  set chan [stl $chan]
  if {[isop $newnick $chan]} {return 0}
  if {$sl_ban != 0} {
    if {!$sl_locked($chan) && $newnick != $botnick && ![matchattr $hand f|f $chan]} {
      set bhost *!*[stl [string range $uhost [string first @ $uhost] end]]
      lappend sl_nkbanhost($chan) $bhost
      utimer [lindex $sl_nkflood 1] "sl_nkbanqueue [split $chan]"
    }
  }
  if {!$sl_nickkick && $sl_flooded($chan) && $sl_locked($chan)} {
    putserv "KICK $chan $newnick :NICK flooder"
    set sl_nickkick 1
    set sl_nkflooding($chan) [unixtime]
    if {$sl_ban != 0} {
      set bhost *!*[stl [string range $uhost [string first @ $uhost] end]]
      if {$sl_globalban} {
        if {[llength [banlist]] < $sl_banmax && ![isban $bhost] && ![ispermban $bhost]} {
          newban $bhost sentinel "NICK flooder" $sl_ban
        }
      } else {
        if {[llength [banlist $chan]] < $sl_banmax && ![isban $bhost $chan] && ![ispermban $bhost $chan]} {
          newchanban $chan $bhost sentinel "NICK flooder" $sl_ban
        }
      }
    }
    utimer [expr [rand 2] + 3] "set sl_nickkick 0"
    return 0
  }
  if {$sl_flooded($chan)} {return 0}
  incr sl_nkqueue($chan)
  utimer [lindex $sl_nkflood 1] "sl_nkqueuereset [split $chan]"
  if {$sl_nkqueue($chan) >= [lindex $sl_nkflood 0]} {
    sl_lock $chan "NICK flood" ${botnet-nick}
  }
}

proc sl_jflood {nick uhost hand chan} {
  global botnet-nick botnick sl_ban sl_banmax sl_boban sl_bobanhost sl_bobannick sl_boflood sl_boqueue sl_flooded sl_globalban sl_jbanhost\
  sl_jbannick sl_jflood sl_jqueue sl_locked sl_pqueue
  if {$nick == $botnick} {return 0}
  set ihost *!*[stl [string range $uhost [string first @ $uhost] end]]
  if {[isignore $ihost]} {
    killignore $ihost
  }
  set chan [stl $chan]
  if {[lsearch -exact $sl_boflood 0] == -1 && [sl_checkbogus [lindex [split $uhost @] 0]]} {
    if {$sl_ban != 0 && !$sl_locked($chan) && ![matchattr $hand f|f $chan]} {
      set bhost *!*[stl [string range $uhost [string first @ $uhost] end]]
      if {$sl_boban != 0 && [botisop $chan] && !$sl_flooded($chan)} {
        putserv "KICK $chan $nick :BOGUS username"
        if {$sl_globalban} {
          if {[llength [banlist]] < $sl_banmax && ![isban $bhost] && ![ispermban $bhost]} {
            newban $bhost sentinel "BOGUS username" $sl_boban
          }
        } else {
          if {[llength [banlist $chan]] < $sl_banmax && ![isban $bhost $chan] && ![ispermban $bhost $chan]} {
            newchanban $chan $bhost sentinel "BOGUS username" $sl_boban
          }
        }
      }
      lappend sl_bobannick($chan) $nick
      lappend sl_bobanhost($chan) $bhost
      utimer [lindex $sl_boflood 1] "sl_bobanqueue [split $chan]"
    }
    if {!$sl_flooded($chan)} {
      incr sl_boqueue($chan)
      utimer [lindex $sl_boflood 1] "sl_boqueuereset [split $chan]"
      if {$sl_boqueue($chan) >= [lindex $sl_boflood 0]} {
        sl_lock $chan "BOGUS joins" ${botnet-nick}
      }
    }
  }
  if {[lsearch -exact $sl_jflood 0] == -1} {
    if {$sl_ban != 0 && !$sl_locked($chan) && ![matchattr $hand f|f $chan]} {
      set bhost *!*[stl [string range $uhost [string first @ $uhost] end]]
      lappend sl_jbannick($chan) $nick
      lappend sl_jbanhost($chan) $bhost
      utimer [lindex $sl_jflood 1] "sl_jbanqueue [split $chan]"
    }
    if {$sl_flooded($chan)} {return 0}
    incr sl_jqueue($chan)
    utimer [lindex $sl_jflood 1] "sl_jqueuereset [split $chan]"
    if {$sl_jqueue($chan) >= [lindex $sl_jflood 0] && $sl_pqueue($chan) >= [lindex $sl_jflood 0]} {
      sl_lock $chan "JOIN-PART flood" ${botnet-nick}
    }
  }
}

proc sl_checkbogus {ident} {
  if {[regsub -all -- "\[^\041-\176\]" $ident "" temp] >= 1} {return 1}
  return 0
}

proc sl_pflood {nick uhost hand chan} {
  global botnick sl_ban sl_flooded sl_jflood sl_locked sl_pbanhost sl_pbannick sl_pqueue
  if {[lsearch -exact $sl_jflood 0] != -1} {return 0}
  if {$nick == $botnick} {return 0}
  set chan [stl $chan]
  if {$sl_ban != 0 && !$sl_locked($chan) && ![matchattr $hand f|f $chan]} {
    set bhost *!*[stl [string range $uhost [string first @ $uhost] end]]
    lappend sl_pbannick($chan) $nick
    lappend sl_pbanhost($chan) $bhost
    utimer [lindex $sl_jflood 1] "sl_jbanqueue [split $chan]"
  }
  if {$sl_flooded($chan)} {return 0}
  incr sl_pqueue($chan)
  utimer [lindex $sl_jflood 1] "sl_pqueuereset [split $chan]"
}

proc sl_pfloodk {nick uhost hand chan kicked reason} {
  global botnick sl_flooded sl_jflood sl_pqueue
  if {[lsearch -exact $sl_jflood 0] != -1} {return 0}
  if {$kicked == $botnick} {return 0}
  set chan [stl $chan]
  if {$sl_flooded($chan)} {return 0}
  incr sl_pqueue($chan)
  utimer [lindex $sl_jflood 1] "sl_pqueuereset [split $chan]"
}

proc sl_lock {chan flood detected} {
  global botnet-nick sl_bflooded sl_cfnotice sl_flooded sl_ilocktime sl_mlocktime sl_note
  if {[botisop $chan]} {
    putquick "MODE $chan +mi"
    set sl_flooded($chan) 1
    set sl_bflooded 1
    foreach utimer [utimers] {
      if {[string match "sl_unlock $chan*" [lindex $utimer 1]] || [string match "set sl_bflooded 0" [lindex $utimer 1]]} {
        killutimer [lindex $utimer 2]
      }
    }
    if {$sl_mlocktime != 0} {
      utimer $sl_mlocktime "sl_unlock [split $chan] m"
    }
    if {$sl_ilocktime != 0} {
      utimer $sl_ilocktime "sl_unlock [split $chan] i"
    }
    utimer 120 "set sl_bflooded 0"
    if {$detected != ${botnet-nick}} {
      putlog "sentinel: $flood detected by $detected on $chan! Channel locked temporarily."
    } else {
      putlog "sentinel: $flood detected on $chan! Channel locked temporarily."
    }
    if {$sl_cfnotice != ""} {
      puthelp "NOTICE $chan :$sl_cfnotice"
    }
    foreach recipient [split $sl_note] {
      if {[validuser $recipient]} {
        sendnote SENTINEL $recipient "Locked $chan due to $flood."
      }
    }
  } else {
    set sl_flooded($chan) 1
    set sl_bflooded 1
    if {$detected != ${botnet-nick}} {
      putlog "sentinel: $flood detected by $detected on $chan! Cannot lock channel because I'm not opped."
    } else {
      putlog "sentinel: $flood detected on $chan! Cannot lock channel because I'm not opped."
    }
    utimer 120 "set sl_bflooded 0"
  }
  if {$detected == ${botnet-nick}} {
    nb_sendcmd * "sl_lock $chan $flood"
  }
}

proc nb_sl_lock {frombot arg} {
  global sl_flooded
  set chan [slindex $arg 0]
  if {[validchan $chan] && [botonchan $chan] && !$sl_flooded($chan)} {
    sl_lock $chan [join [lrange [split $arg] 1 end]] $frombot
  }
}

proc sl_unlock {chan umode} {
  global sl_bflooded sl_bfmaxbans sl_flooded sl_ilocktime sl_mlocktime sl_nkflooding
  if {[expr [unixtime] - $sl_nkflooding($chan)] < 12} {
    putlog "sentinel: nick flooding still in progress on $chan - not removing +mi yet.."
    set sl_flooded($chan) 1
    set sl_bflooded 1
    foreach utimer [utimers] {
      if {[string match "sl_unlock $chan*" [lindex $utimer 1]] || [string match "set sl_bflooded 0" [lindex $utimer 1]]} {
        killutimer [lindex $utimer 2]
      }
    }
    utimer $sl_mlocktime "sl_unlock [split $chan] m"
    utimer $sl_ilocktime "sl_unlock [split $chan] i"
    utimer 120 "set sl_bflooded 0"
  } else {
    set sl_flooded($chan) 0
    if {![botisop $chan]} {return 0}
    if {$umode == "i" && [string match *i* [lindex [getchanmode $chan] 0]]} {
      if {$sl_bfmaxbans != 0 && [llength [chanbans $chan]] >= $sl_bfmaxbans} {
        putlog "sentinel: not removing +i on $chan due to full ban list."
      } else {
        pushmode $chan -i
        putlog "sentinel: removed +i on $chan"
      }
    } elseif {$umode == "m" && [string match *m* [lindex [getchanmode $chan] 0]]} {
      pushmode $chan -m
      putlog "sentinel: removed +m on $chan"
    }
  }
}

proc sl_mode {nick uhost hand chan mode victim} {
  global sl_ban sl_bfmaxbans sl_bfnotice sl_bfull sl_flooded sl_locked sl_note
  set mode [slindex $mode 0]
  set chan [stl $chan]
  if {$mode == "+b" && $sl_bfmaxbans != 0 && !$sl_bfull($chan) && ![string match *i* [lindex [getchanmode $chan] 0]] && [botisop $chan] &&\
  [llength [chanbans $chan]] >= $sl_bfmaxbans} {
    putserv "MODE $chan +i"
    set sl_bfull($chan) 1
    utimer 5 "set sl_bfull([split $chan]) 0"
    putlog "sentinel: locked $chan due to full ban list!"
    if {$sl_bfnotice != ""} {
      puthelp "NOTICE $chan :$sl_bfnotice"
    }
    foreach recipient [split $sl_note] {
      if {[validuser $recipient]} {
        sendnote SENTINEL $recipient "Locked $chan due to full ban list."
      }
    }
  } elseif {$mode == "+i" && $sl_flooded($chan)} {
    set sl_locked($chan) 1
    if {$sl_ban != 0} {
      foreach utimer [utimers] {
        if {[string match "sl_*banqueue $chan" [lindex $utimer 1]]} {
          killutimer [lindex $utimer 2]
        }
      }
      utimer 6 "sl_dokicks [split $chan]"
      utimer 14 "sl_setbans [split $chan]"
    }
  } elseif {$mode == "-i" || $mode == "-m"} {
    set sl_locked($chan) 0
    if {$sl_flooded($chan)} {
      set sl_flooded($chan) 0
      foreach utimer [utimers] {
        if {[string match "sl_unlock $chan*" [lindex $utimer 1]]} {
          killutimer [lindex $utimer 2]
        }
      }
    }
  }
}

proc sl_dokicks {chan} {
  global sl_avbannick sl_bobannick sl_ccbannick sl_flooders sl_jbannick sl_pbannick
  if {![botonchan $chan] || ![botisop $chan]} {return 0}
  set sl_flooders 0
  sl_kick $chan $sl_ccbannick($chan) "CTCP flooder"
  set sl_ccbannick($chan) ""
  sl_kick $chan $sl_avbannick($chan) "AVALANCHE flooder"
  set sl_avbannick($chan) ""
  sl_kick $chan $sl_bobannick($chan) "BOGUS username"
  set sl_bobannick($chan) ""
  set jklist $sl_jbannick($chan)
  set pklist $sl_pbannick($chan)
  if {$jklist != "" && $pklist != ""} {
    set klist ""
    foreach knick $jklist {
      if {[lsearch -exact $pklist $knick] != -1} {
        lappend klist $knick
      }
    }
    sl_kick $chan $klist "JOIN-PART flooder"
  }
  set sl_jbannick($chan) ""
  set sl_pbannick($chan) ""
}

proc sl_setbans {chan} {
  global sl_avbanhost sl_bobanhost sl_ccbanhost sl_flooders sl_jbanhost sl_nkbanhost sl_pbanhost sl_shortlock
  if {![botonchan $chan]} {return 0}
  sl_ban $chan $sl_ccbanhost($chan) "CTCP flooder"
  set sl_ccbanhost($chan) ""
  sl_ban $chan $sl_avbanhost($chan) "AVALANCHE flooder"
  set sl_avbanhost($chan) ""
  sl_ban $chan $sl_nkbanhost($chan) "NICK flooder"
  set sl_nkbanhost($chan) ""
  sl_ban $chan $sl_bobanhost($chan) "BOGUS username"
  set sl_bobanhost($chan) ""
  set jblist $sl_jbanhost($chan)
  set pblist $sl_pbanhost($chan)
  if {$jblist != "" && $pblist != ""} {
    set blist ""
    foreach bhost $jblist {
      if {[lsearch -exact $pblist $bhost] != -1} {
        lappend blist $bhost
      }
    }
    sl_ban $chan $blist "JOIN-PART flooder"
  }
  set sl_jbanhost($chan) ""
  set sl_pbanhost($chan) ""
  if {$sl_shortlock && $sl_flooders <= 2} {
    foreach utimer [utimers] {
      if {[string match "sl_unlock $chan*" [lindex $utimer 1]]} {
        killutimer [lindex $utimer 2]
      }
    }
    utimer 5 "sl_unlock [split $chan] m"
    utimer 5 "sl_unlock [split $chan] i"
  }
}

proc sl_kick {chan klist reason} {
  global sl_flooders sl_kick
  if {$klist != ""} {
    set kicklist ""
    foreach knick $klist {
      if {[lsearch -exact $kicklist $knick] == -1} {
        lappend kicklist $knick
      }
    }
    set sl_flooders [llength $kicklist]
    foreach knick $kicklist {
      if {[nb_onchan $knick $chan]} {
        lappend ksend $knick
        if {[llength $ksend] >= $sl_kick} {
          set ksend [join $ksend ","]
          putserv "KICK $chan $ksend :$reason"
          unset ksend
        }
      }
    }
    if {[info exists ksend]} {
      set ksend [join $ksend ","]
      putserv "KICK $chan $ksend :$reason"
      unset ksend
    }
  }
}

proc sl_ban {chan blist reason} {
  global sl_ban sl_banmax sl_globalban
  if {$blist != ""} {
    set banlist ""
    foreach bhost $blist {
      if {[lsearch -exact $banlist $bhost] == -1} {
        lappend banlist $bhost
      }
    }
    if {$sl_globalban} {
      foreach bhost $banlist {
        if {[llength [banlist]] >= $sl_banmax || [isban $bhost] || [ispermban $bhost]} {continue}
        newban $bhost sentinel $reason $sl_ban
        putlog "sentinel: banned $bhost ($reason)"
        sl_ignore $bhost * $reason
      }
    } else {
      foreach bhost $banlist {
        if {[llength [banlist $chan]] >= $sl_banmax || [isban $bhost $chan] || [ispermban $bhost $chan]} {continue}
        newchanban $chan $bhost sentinel $reason $sl_ban
        putlog "sentinel: banned $bhost on $chan ($reason)"
        sl_ignore $bhost * $reason
      }
    }
  }
}

proc sl_ignore {uhost hand flood} {
  global sl_igtime
  if {$hand != "*"} {
    foreach chan [stl [channels]] {
      if {[matchattr $hand f|f $chan]} {return 0}
    }
  }
  set ihost *!*[stl [string range $uhost [string first @ $uhost] end]]
  if {[isignore $ihost]} {return 1}
  newignore $ihost sentinel $flood $sl_igtime
  putlog "sentinel: added $ihost to ignore list ($flood)"
  return 1
}

proc sl_ccqueuereset {chan} {
  global sl_ccqueue
  incr sl_ccqueue($chan) -1
}

proc sl_bcqueuereset {} {
  global sl_bcqueue
  incr sl_bcqueue -1
}

proc sl_bmqueuereset {} {
  global sl_bmqueue
  incr sl_bmqueue -1
}

proc sl_avqueuereset {chan} {
  global sl_avqueue
  incr sl_avqueue($chan) -1
}

proc sl_txqueuereset {} {
  global sl_txqueue sl_txflood
  foreach chan [string tolower [channels]] {
    if {[info exists sl_txqueue($chan)]} {
      set sl_txqueue($chan) 0
    }
  }
  utimer [lindex $sl_txflood 1] sl_txqueuereset
}

proc sl_nkqueuereset {chan} {
  global sl_nkqueue
  incr sl_nkqueue($chan) -1
}

proc sl_boqueuereset {chan} {
  global sl_boqueue
  incr sl_boqueue($chan) -1
}

proc sl_jqueuereset {chan} {
  global sl_jqueue
  incr sl_jqueue($chan) -1
}

proc sl_pqueuereset {chan} {
  global sl_pqueue
  incr sl_pqueue($chan) -1
}

proc sl_ccbanqueue {chan} {
  global sl_ccbanhost sl_ccbannick
  set sl_ccbannick($chan) [lrange sl_ccbannick($chan) 1 end]
  set sl_ccbanhost($chan) [lrange sl_ccbanhost($chan) 1 end]
}

proc sl_avbanqueue {chan} {
  global sl_avbanhost sl_avbannick
  set sl_avbannick($chan) [lrange sl_avbannick($chan) 1 end]
  set sl_avbanhost($chan) [lrange sl_avbanhost($chan) 1 end]
}

proc sl_nkbanqueue {chan} {
  global sl_nkbanhost
  set sl_nkbanhost($chan) [lrange sl_nkbanhost($chan) 1 end]
}

proc sl_bobanqueue {chan} {
  global sl_bobanhost sl_bobannick
  set sl_bobannick($chan) [lrange sl_bobannick($chan) 1 end]
  set sl_bobanhost($chan) [lrange sl_bobanhost($chan) 1 end]
}

proc sl_jbanqueue {chan} {
  global sl_jbanhost sl_jbannick
  set sl_jbannick($chan) [lrange sl_jbannick($chan) 1 end]
  set sl_jbanhost($chan) [lrange sl_jbanhost($chan) 1 end]
}

proc sl_pbanqueue {chan} {
  global sl_pbanhost sl_pbannick
  set sl_pbannick($chan) [lrange sl_pbannick($chan) 1 end]
  set sl_pbanhost($chan) [lrange sl_pbanhost($chan) 1 end]
}

proc sl_flud {nick uhost hand type chan} {
  global sl_flooded
  set chan [stl $chan]
  if {[validchan $chan] && $sl_flooded($chan)} {return 1}
}

proc sl_lc {nick uhost hand chan arg} {
  global sl_lockcmds
  set chan [stl $chan]
  if {![botisop $chan]} {return 0}
  if {$sl_lockcmds == 2 && ![isop $nick $chan]} {return 0}
  putquick "MODE $chan +mi"
  putcmdlog "sentinel: channel lock requested by $hand on $chan"
}

proc sl_uc {nick uhost hand chan arg} {
  global sl_lockcmds
  set chan [stl $chan]
  if {![botisop $chan]} {return 0}
  if {$sl_lockcmds == 2 && ![isop $nick $chan]} {return 0}
  putserv "MODE $chan -mi"
  putcmdlog "sentinel: channel unlock requested by $hand on $chan"
}

proc sl_dcclc {hand idx arg} {
  global sl_lockflags
  set chan [stl [slindex $arg 0]]
  if {$chan == ""} {
    set chan [slindex [console $idx] 0]
  }
  if {![validchan $chan]} {
    putidx $idx "No such channel."
    return 0
  } elseif {![matchattr $hand $sl_lockflags|$sl_lockflags $chan]} {
    putidx $idx "You're not +$sl_lockflags on $chan."
    return 0
  } elseif {![botonchan $chan]} {
    putidx $idx "I'm not on $chan"
    return 0
  } elseif {![botisop $chan]} {
    putidx $idx "I'm not opped on $chan"
    return 0
  }
  putcmdlog "#$hand# lc $arg"
  putquick "MODE $chan +mi"
  putidx $idx "Locked $chan"
}

proc sl_dccuc {hand idx arg} {
  global sl_lockflags
  set chan [stl [slindex $arg 0]]
  if {$chan == ""} {
    set chan [slindex [console $idx] 0]
  }
  if {![validchan $chan]} {
    putidx $idx "No such channel."
    return 0
  } elseif {![matchattr $hand $sl_lockflags|$sl_lockflags $chan]} {
    putidx $idx "You're not +$sl_lockflags on $chan."
    return 0
  } elseif {![botonchan $chan]} {
    putidx $idx "I'm not on $chan"
    return 0
  } elseif {![botisop $chan]} {
    putidx $idx "I'm not opped on $chan"
    return 0
  }
  putcmdlog "#$hand# uc $arg"
  putserv "MODE $chan -mi"
  putidx $idx "Unlocked $chan"
}

proc sl_dcc {hand idx arg} {
  global sl_avflood sl_ban sl_banmax sl_bcflood sl_boban sl_boflood sl_bmflood sl_bxsimul sl_bfmaxbans sl_ccflood sl_globalban sl_igtime sl_jflood\
  sl_kick sl_lockcmds sl_lockflags sl_ilocktime sl_mlocktime sl_nkflood sl_note sl_txflood
  putcmdlog "#$hand# sentinel $arg"
  putidx $idx "This bot is protected by sentinel.tcl by slennox"
  putidx $idx "Current settings"
  if {$sl_bcflood == 0} {
    putidx $idx "- Bot CTCP flood:           Off"
  } else {
    putidx $idx "- Bot CTCP flood:           [lindex $sl_bcflood 0] in [lindex $sl_bcflood 1] secs"
  }
  if {$sl_bmflood == 0} {
    putidx $idx "- Bot MSG flood:            Off"
  } else {
    putidx $idx "- Bot MSG flood:            [lindex $sl_bmflood 0] in [lindex $sl_bmflood 1] secs"
  }
  if {$sl_ccflood == 0} {
    putidx $idx "- Channel CTCP flood:       Off"
  } else {
    putidx $idx "- Channel CTCP flood:       [lindex $sl_ccflood 0] in [lindex $sl_ccflood 1] secs"
  }
  if {$sl_avflood == 0} {
    putidx $idx "- Channel AVALANCHE flood:  Off"
  } else {
    putidx $idx "- Channel AVALANCHE flood:  [lindex $sl_avflood 0] in [lindex $sl_avflood 1] secs"
  }
  if {$sl_txflood == 0} {
    putidx $idx "- Channel TEXT flood:       Off"
  } else {
    putidx $idx "- Channel TEXT flood:       [lindex $sl_txflood 0] in [lindex $sl_txflood 1] secs"
  }
  if {$sl_boflood == 0} {
    putidx $idx "- Channel BOGUS flood:      Off"
  } else {
    putidx $idx "- Channel BOGUS flood:      [lindex $sl_boflood 0] in [lindex $sl_boflood 1] secs"
  }
  if {$sl_jflood == 0} {
    putidx $idx "- Channel JOIN-PART flood:  Off"
  } else {
    putidx $idx "- Channel JOIN-PART flood:  [lindex $sl_jflood 0] in [lindex $sl_jflood 1] secs"
  }
  if {$sl_nkflood == 0} {
    putidx $idx "- Channel NICK flood:       Off"
  } else {
    putidx $idx "- Channel NICK flood:       [lindex $sl_nkflood 0] in [lindex $sl_nkflood 1] secs"
  }
  if {$sl_ilocktime == 0} {
    putidx $idx "- Channel +i locktime:      Indefinite"
  } else {
    putidx $idx "- Channel +i locktime:      $sl_ilocktime secs"
  }
  if {$sl_mlocktime == 0} {
    putidx $idx "- Channel +m locktime:      Indefinite"
  } else {
    putidx $idx "- Channel +m locktime:      $sl_mlocktime secs"
  }
  if {$sl_ban > 0 && $sl_ban < 120} {
    putidx $idx "- Channel flood bans:       $sl_ban mins"
  } elseif {$sl_ban >= 120} {
    putidx $idx "- Channel flood bans:       [expr $sl_ban / 60] hrs"
  } else {
    putidx $idx "- Channel flood bans:       Disabled"
  }
  if {$sl_boban > 0 && $sl_boban < 120} {
    putidx $idx "- Bogus username bans:      $sl_boban mins"
  } elseif {$sl_ban >= 120} {
    putidx $idx "- Bogus username bans:      [expr $sl_boban / 60] hrs"
  } else {
    putidx $idx "- Bogus username bans:      Disabled"
  }
  if {$sl_globalban && $sl_ban > 0} {
    putidx $idx "- Ban type:                 Global"
  } elseif {!$sl_globalban && $sl_ban > 0} {
    putidx $idx "- Ban type:                 Channel-specific"
  }
  if {$sl_ban > 0} {
    putidx $idx "- Maximum bans:             $sl_banmax"
  }
  if {$sl_igtime > 0 && $sl_igtime < 120} {
    putidx $idx "- Flooder ignores:          $sl_igtime mins"
  } elseif {$sl_igtime >= 120} {
    putidx $idx "- Flooder ignores:          [expr $sl_igtime / 60] hrs"
  } else {
    putidx $idx "- Flooder ignores:          Permanent"
  }
  if {$sl_ban > 0} {
    putidx $idx "- Kicks per line:           $sl_kick"
  }
  if {$sl_bfmaxbans == 0} {
    putidx $idx "- Maximum channel bans:     Disabled"
  } else {
    putidx $idx "- Maximum channel bans:     $sl_bfmaxbans"
  }
  if {$sl_note != ""} {
    putidx $idx "- Flood notification:       Notifying [join [split $sl_note] ", "]"
  } else {
    putidx $idx "- Flood notification:       Off"
  }
  if {$sl_lockcmds == 0} {
    putidx $idx "- Public lc/uc commands:    Disabled"
  } elseif {$sl_lockcmds == 1} {
    putidx $idx "- Public lc/uc commands:    Enabled (+$sl_lockflags users, ops not required)"
  } elseif {$sl_lockcmds == 2} {
    putidx $idx "- Public lc/uc commands:    Enabled (+$sl_lockflags users, ops required)"
  }
  if {$sl_bxsimul} {
    putidx $idx "- BitchX simulation:        On"
  } elseif {!$sl_bxsimul} {
    putidx $idx "- BitchX simulation:        Off"
  }
}

if {$sl_bxsimul} {
  bind raw - 002 sl_bxserverjoin
  set sl_bxonestack 0
  set sl_bxversion "75p1+"
  set sl_bxsystem "*IX"
  catch {set sl_bxsystem [exec uname -s -r]}
  set sl_bxwhoami $username
  catch {set sl_bxwhoami [exec whoami]}
  set sl_bxmachine ""
  catch {set sl_bxmachine [exec uname -n]}
  set sl_bxjointime [unixtime]
  proc sl_bxserverjoin {from keyword arg} {
    global botnick sl_bxjointime sl_bxisaway
    set sl_bxjointime [unixtime]
    set sl_bxisaway 0
  }
  proc sl_bxaway {} {
    global sl_bxisaway botnick
    if {!$sl_bxisaway} {
      putserv "AWAY :is away: (Auto-Away after 10 mins) \[\002BX\002-MsgLog On\]"
      set sl_bxisaway 1
    } else {
      putserv "AWAY"
      set sl_bxisaway 0
    }
    timer [expr [rand 300] + 10] sl_bxaway
  }
}

if {$sl_bxsimul && ![info exists sl_bxawaytmr]} {
  set sl_bxawaytmr 1
  set sl_bxisaway 0
  timer [expr [rand 300] + 10] sl_bxaway
}

proc sl_setarray {nick uhost hand chan} {
  global botnick sl_avbanhost sl_avbannick sl_avqueue sl_bfull sl_bobanhost sl_bobannick sl_boqueue sl_ccbanhost sl_ccbannick sl_ccqueue sl_flooded\
  sl_jbanhost sl_jbannick sl_jqueue sl_locked sl_nkbanhost sl_nkflooding sl_nkqueue sl_pbanhost sl_pbannick sl_pqueue sl_txqueue
  if {$nick != $botnick} {return 0}
  set chan [stl $chan]
  foreach utimer [utimers] {
    set tmrproc [lindex $utimer 1]
    if {[string match "sl_*queuereset $chan" $tmrproc] && ![string match "sl_txqueuereset*" $tmrproc]} {
      killutimer [lindex $utimer 2]
    } elseif {[string match "sl_*banqueue $chan" $tmrproc]} {
      killutimer [lindex $utimer 2]
    }
  }
  set sl_flooded($chan) 0
  set sl_locked($chan) 0
  set sl_nkflooding($chan) [unixtime]
  set sl_ccqueue($chan) 0
  set sl_ccbanhost($chan) ""
  set sl_ccbannick($chan) ""
  set sl_avqueue($chan) 0
  set sl_avbanhost($chan) ""
  set sl_avbannick($chan) ""
  set sl_txqueue($chan) 0
  set sl_nkqueue($chan) 0
  set sl_nkbanhost($chan) ""
  set sl_boqueue($chan) 0
  set sl_bobanhost($chan) ""
  set sl_bobannick($chan) ""
  set sl_jqueue($chan) 0
  set sl_jbanhost($chan) ""
  set sl_jbannick($chan) ""
  set sl_pqueue($chan) 0
  set sl_pbanhost($chan) ""
  set sl_pbannick($chan) ""
  set sl_bfull($chan) 0
}

if {![info exists sl_nkflooding]} {
  foreach sl_chan [string tolower [channels]] {
    sl_setarray $botnick * * $sl_chan
  }
  unset sl_chan
}

if {![info exists sl_bflooded]} {
  set sl_bflooded 0
}
if {![info exists sl_bcqueue]} {
  set sl_bcqueue 0
}
if {![info exists sl_bmqueue]} {
  set sl_bmqueue 0
}
if {![info exists sl_nickkick]} {
  set sl_nickkick 0
}

set sl_bcflood [split $sl_bcflood :]
set sl_bmflood [split $sl_bmflood :]
set sl_ccflood [split $sl_ccflood :]
set sl_avflood [split $sl_avflood :]
set sl_txflood [split $sl_txflood :]
set sl_boflood [split $sl_boflood :]
set sl_jflood [split $sl_jflood :]
set sl_nkflood [split $sl_nkflood :]

if {$sl_ilocktime > 0 && $sl_ilocktime < 20} {
  set sl_ilocktime 20
}
if {$sl_mlocktime > 0 && $sl_mlocktime < 20} {
  set sl_mlocktime 20
}

set trigger-on-ignore 0

if {$numversion >= 1032100} {
  set kick-bogus 0
}

if {$numversion >= 1032400} {
  set ban-bogus 0
  set kick-fun 0
  set ban-fun 0
}

if {$numversion >= 1032500} {
  set ctcp-mode 0
}

if {![string match *sl_txqueuereset* [utimers]] && [lsearch -exact $sl_txflood 0] == -1} {
  global sl_txflood
  utimer [lindex $sl_txflood 1] sl_txqueuereset
}

bind pub $sl_lockflags|$sl_lockflags lc sl_lc
bind pub $sl_lockflags|$sl_lockflags uc sl_uc
bind dcc $sl_lockflags|$sl_lockflags lc sl_dcclc
bind dcc $sl_lockflags|$sl_lockflags uc sl_dccuc
if {!$sl_lockcmds} {
  unbind pub $sl_lockflags|$sl_lockflags lc sl_lc
  unbind pub $sl_lockflags|$sl_lockflags uc sl_uc
}
catch {unbind bot - nb_sl_lock nb_sl_lock}
bind dcc m|m sentinel sl_dcc
bind raw - NOTICE sl_avflood
bind raw - PRIVMSG sl_avflood
bind ctcp - CLIENTINFO sl_ctcp
bind ctcp - USERINFO sl_ctcp
bind ctcp - VERSION sl_ctcp
bind ctcp - FINGER sl_ctcp
bind ctcp - ERRMSG sl_ctcp
bind ctcp - ECHO sl_ctcp
bind ctcp - INVITE sl_ctcp
bind ctcp - WHOAMI sl_ctcp
bind ctcp - OP sl_ctcp
bind ctcp - OPS sl_ctcp
bind ctcp - UNBAN sl_ctcp
bind ctcp - PING sl_ctcp
bind ctcp - TIME sl_ctcp
bind msgm - * sl_bmflood
bind nick - * sl_nkflood
bind join - * sl_setarray
bind join - * sl_jflood
bind part - * sl_pflood
bind kick - * sl_pfloodk
bind flud - * sl_flud
bind mode - * sl_mode
}


# serverlist.tcl

if {$nb_component(serverlist)} {
proc sv_randomise {} {
  global servers sv_servers
  set list $sv_servers
  set randlist ""
  while {[llength $list] > 0} {
    set random [rand [llength $list]]
    lappend randlist [lindex $list $random]
    set list [lreplace $list $random $random]
  }
  set servers $randlist
}

sv_randomise
}


# superbitch.tcl

if {$nb_component(superbitch)} {
proc sb_bitch {nick uhost hand chan mode opped} {
  global botnick sb_chans sb_canop sb_canopany sb_canopflags sb_note sb_remove
  if {$mode != "+o" || [stl $opped] == [stl $botnick] || [stl $nick] == [stl $botnick] || [stl $nick] == [stl $opped] || ![onchan $nick $chan] ||\
  [isop $opped $chan]} {return 0}
  if {$sb_chans != "" && [lsearch -exact [split $sb_chans] [stl $chan]] == -1} {return 0}
  if {![matchattr [nick2hand $opped $chan] $sb_canopflags|$sb_canopflags $chan]} {
    if {$sb_canopany != "" && [matchattr $hand $sb_canopany|$sb_canopany $chan]} {return 0}
    pushmode $chan -o $opped
    pushmode $chan -o $nick
    if {$sb_remove && [validuser $hand] && [matchattr $hand o|o $chan]} {
      chattr $hand -o|-o $chan
      foreach recipient [split $sb_note] {
        if {[validuser $recipient]} {
          sendnote SUPERBITCH $recipient "Removed +o from $hand (opped $opped on $chan)"
        }
      }
    }
  } else {
    if {$sb_canopany != "" && [matchattr $hand $sb_canopany|$sb_canopany $chan]} {return 0}
    if {$sb_canop != "" && [matchattr $hand $sb_canop|$sb_canop $chan]} {return 0}
    pushmode $chan -o $opped
    pushmode $chan -o $nick
    if {$sb_remove && [validuser $hand] && [matchattr $hand o|o $chan]} {
      chattr $hand -o|-o $chan
      foreach recipient [split $sb_note] {
        if {[validuser $recipient]} {
          sendnote SUPERBITCH $recipient "Removed +o from $hand (opped $opped on $chan)"
        }
      }
    }
  }
}

set sb_chans [stl $sb_chans]

bind mode - * sb_bitch
}

# End of main script and components

# Start of additional components


# End of additional components

set nb_components "netbots"
foreach nb_cscript [array names nb_component] {
  if {$nb_component($nb_cscript)} {
    lappend nb_components $nb_cscript
  }
}
unset nb_cscript
set nb_components [lsort $nb_components]
regsub -all -- " " [join $nb_components] ", " nb_components
putlog "Loaded components: $nb_components"
